'''WOD Rescript begun on 10/31/08
    Make code neater, more effective, and expand upon what I already have
    
    Done List:
        Merrits -
            Resources
            Fleet of Foot
            Fighting Finesse
            Unseen Sense
            Danager Sense
            Quick Healer
            Psyic Healer
            Iron Stamina
            Biokinesis
        
        Attributes -
            Strength
            Dexterity
            Stamina
            Presence
        
        Skills -
            Firearms
            Stealth
            Athletics
            Subterfuge
            Larceny
            Occult
        
        Templates -
            Werewolf
            Vampire
            Psion
        
        Commands - 
            +/-sprint
        
        Misc -
            Scaling Speed and Damage
            Red Screen
            Flash when hit
    To Do:
        Attributes - Intelligence
        Skill - Medicine
        
    Ideas for Future:
        Template - Mage
        Skill - Computers (Maybe a Bank)
        Merrit - Pyrokinesis'''

#Imports for all the different libararies our mod will use
import es, popuplib, random, inputlib, cPickle, os.path, string, math, gamethread, playerlib

#Global Vars

#Sets up our public Server Var that things like game monitor can read
info = es.AddonInfo()
info.name = 'World of Darkness'
info.version = 'BETA 1.02'
info.url = 'http://addons.eventscripts.com/addons/view/worldofdarkness'
info.basename = 'worldofdarkness'
info.author = 'Jeff Hoogland'
es.ServerVar('WorldofDarkness',info.version,'World of Darkness By: Jeff Hoogland').makepublic()

#Get tacked onto the end of a user's name if the character they try to make is already taken
sufixes = ['the Crazy', 'the Random', 'the Sly', 'the Young', 'the Strong', 'the Creepy', 'the Great', 'the Powerful', 'the Mighty', 'the Pythonic', 'the Sneaky', 'the Sexy', 'the Bashful', 'the Brave']

#Common words players use that will display the main menu if anohter mod is not using them
MenuCommands = ['menu', 'help', 'modmenu', 'helpmenu', 'wodmenu', '!menu', 'rpgmenu', 'changerace', 'wcsmenu']

#Three storage dicts, Characters is accessed directly, while IDStorage is used through the 'Bank' methond and Users is through the 'getPlayer' method
Characters = {}
IDStorage = {}
Users = {}

#Keeps track of which guns are which types
Pistols = ['glock','usp','p228','deagle','fiveseven','elite']
ShotGuns = ['m3','xm1014']
SMGs = ['mac10','tmp','ump45','mp5navy','p90']
Rifles = ['gali','famas','m4a1','ak47','sg552','aug']
Snipers = ['scout','awp','sg550','g3sg1']
Grenades = ['hegrenade','flashbang','smokegrenade']
Weapons = ['ak47','m4a1','galil','famas','sg552','aug','glock','usp','p228','deagle','fiveseven','elite','m3','xm1014','mac10','tmp','ump45','mp5navy','p90','scout','awp','sg550','g3sg1','hegrenade','flashbang','smokegrenade','m249','knife']
Guns = ['ak47','m4a1','galil','famas','sg552','aug','glock','usp','p228','deagle','fiveseven','elite','m3','xm1014','mac10','tmp','ump45','mp5navy','p90','scout','awp','sg550','g3sg1','m249']

def load():
    '''Runs when the es_load wod is run in server console or via RCON'''
    es.msg('Converting your server to a World of Darkness...')
    global Characters, IDStorage
    str_path = es.getAddonPath('worldofdarkness') + '/Characters.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        Characters = cPickle.load(file_users)
        file_users.close()
    str_path = es.getAddonPath('worldofdarkness') + '/IDStorage.db'
    if os.path.isfile(str_path):
        file_users = open(str_path)
        IDStorage = cPickle.load(file_users)
        file_users.close()
    for userid in es.getUseridList():
        es.server.queuecmd('es_xchangeteam %s 1'%userid)
        ID = Bank(userid)
        if len(ID):
            es.cexec(userid, 'wod load %s'%ID[0])
        else:
            es.cexec(userid, 'wod create %s'%es.getplayername(userid))
    menucreate()
    FadeLoop()
    BotLoad()
    if not es.exists('saycommand', 'wod'):
        es.regsaycmd('wod', 'worldofdarkness/Command')
    if not es.exists('clientcommand', 'wod'):
        es.regclientcmd('wod', 'worldofdarkness/Command')
    if not es.exists('clientcommand', '+sprint'):
        es.regclientcmd('+sprint', 'worldofdarkness/SprintOn')
    if not es.exists('clientcommand', '-sprint'):
        es.regclientcmd('-sprint', 'worldofdarkness/SprintOff')
    for command in MenuCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'worldofdarkness/WrongMenu')
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'worldofdarkness/WrongMenu')
    es.server.queuecmd('est_RegEventBlock player_hurt "es_xdoblock worldofdarkness/prep_hurt"')
    es.msg('Conversion finished... a shadow has fallen across your server.')

def unload():
    '''Runs when the mod is unloaded via es_unload'''
    es.msg('The darkness is breaking...')
    str_path = open(es.getAddonPath('worldofdarkness') + '/Characters.db', 'w')
    cPickle.dump(Characters, str_path)
    str_path.close()
    str_path = open(es.getAddonPath('worldofdarkness') + '/IDStorage.db', 'w')
    cPickle.dump(IDStorage, str_path)
    str_path.close()
    gamethread.cancelDelayed('wod_Fade')
    for userid in es.getUseridList():
        #Stop all pending delays linked to all players on mod unload
        Key = getPlayer(userid)
        while Key['delays'] > 0:
            gamethread.cancelDelayed('%s_%s'%(userid, Key['delays']))
            Key['delays'] -= 1
    es.server.queuecmd('est_UnRegEventBlock player_hurt "es_xdoblock worldofdarkness/prep_hurt"')
    es.msg('Your server has returned to normal.')

#Start Events

#Global Events
def round_start(ev):
    '''Fires every time a round starts'''
    for userid in es.getUseridList():
        if es.getplayerteam(userid) > 1:
            Key = getPlayer(userid)
            Character = Characters[Key['Character']]
            if Character['Attributes']['Presence'] > 2:
                for teammate in es.getUseridList():
                    if teammate != userid:
                        if es.getplayerteam(teammate) == es.getplayerteam(userid):
                            Health(teammate, (Character['Attributes']['Presence']-2)**2)
                            Cash = (Character['Attributes']['Presence']-2)*300
                            es.setplayerprop(teammate, 'CCSPlayer.m_iAccount', es.getplayerprop(teammate, 'CCSPlayer.m_iAccount')+Cash)
            if Character['Skills']['Larceny']:
                for victim in es.getUseridList():
                    if es.getplayerteam(userid) != es.getplayerteam(victim):
                        if Character['Skills']['Larceny']**2 >= random.randint(1, 100):
                            Cash = es.getplayerprop(victim, 'CCSPlayer.m_iAccount')*.25
                            es.tell(userid, '#multi', '#defaultYou have stolen #lightgreen%s #defaultcash from #lightgreen%s'%(Cash, es.getplayername(victim)))
                            es.tell(victim, '#multi', '#lightgreen%s #defaulthas stolen #lightgreen%s #defaultcash from you with Larceny.'%(es.getplayername(userid), Cash))
                            es.setplayerprop(userid, 'CCSPlayer.m_iAccount', es.getplayerprop(userid, 'CCSPlayer.m_iAccount')+Cash)
                            es.setplayerprop(victim, 'CCSPlayer.m_iAccount', es.getplayerprop(victim, 'CCSPlayer.m_iAccount')-Cash)

def round_end(event_var):
    '''Fires every time a round comes to an end, this handels saving character and user infos'''
    str_path = open(es.getAddonPath('worldofdarkness') + '/Characters.db', 'w')
    cPickle.dump(Characters, str_path)
    str_path.close()
    str_path = open(es.getAddonPath('worldofdarkness') + '/IDStorage.db', 'w')
    cPickle.dump(IDStorage, str_path)
    str_path.close()
    winner = int(event_var['winner'])
    if winner > 1:
        #Give xp to users on the T and CT teams at round end
        for userid in es.getUseridList():
            if es.getplayerteam(userid) == winner:
                GiveXp(userid, .5, 'gleaned useful information from your teams victory')
            elif es.getplayerteam(userid) > 1:
                GiveXp(userid, .25, 'reflected on your team\'s failure')
    for userid in es.getUseridList():
        #Stop all pending delays linked to all players on round end
        Key = getPlayer(userid)
        while Key['delays'] > 0:
            gamethread.cancelDelayed('%s_%s'%(userid, Key['delays']))
            Key['delays'] -= 1


#Per User events

def player_hurt(ev):
    '''Runs every time a user takes and/or deals damage'''
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    if ev['damage']:
        damage = int(ev['damage'])
    else:
        damage = 0
    weapon = ev['weapon']
    if attacker:
        AttackerEffects(attacker, userid, damage, weapon)
    VictimEffects(userid, attacker, damage, weapon)

def player_jump(ev):
    '''Runs every time a user jumps'''
    userid = int(ev['userid'])
    Key = getPlayer(userid)
    #Code for long jump provided by SD
    temp_multiplier = Key['jump'] - 1
    es.setplayerprop(userid, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s' % tuple([es.getplayerprop(userid, 'CBasePlayer.localdata.m_vecVelocity[%s]' % x) * temp_multiplier for x in range(3)]))

def player_death(ev):
    '''Runs when ever a user bites the big one'''
    userid = int(ev['userid'])
    Key = getPlayer(userid)
    Character = Characters[Key['Character']]
    while Key['delays'] > 0:
        #Stop all pending delays for a user that dies
        gamethread.cancelDelayed('%s_%s'%(userid, Key['delays']))
        Key['delays'] -= 1

def player_spawn(ev):
    '''Runs when ever a user spawns'''
    userid = int(ev['userid'])
    Key = getPlayer(userid)
    ID = Bank(userid)
    es.tell(userid, '#multi', '#defaultWorld of Darkness Mod - Use #lightgreenwod menu #defaultin chat for a menu.')
    #If a player has no character either A. Load their last loaded, or B. if no characters created make one for them
    if not Key['Character']:
        if len(ID):
            es.cexec(userid, 'wod load %s'%ID[0])
        else:
            es.cexec(userid, 'wod create %s'%es.getplayername(userid))
    if Key['Character']:
        Default(userid)
        SpawnEffects(userid)

def item_pickup(ev):
    '''Runs every time a player picks up an item'''
    userid = int(ev['userid'])
    Key = getPlayer(userid)
    if Key['wolf form'] == 1:
        if ev['item'] in Guns:
            es.server.queuecmd('est_DropWeapon %s weapon_%s'%(userid, ev['item']))

def est_client_keypress(ev):
    '''Is used to track when a user presses certain keys'''
    userid = int(ev['userid'])
    Key = getPlayer(userid)
    if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
        if ev['keyname'] == 'duck' or ev['keyname'] == 'speed':
            if ev['status'] == '1':
                Key['stealth on'] = 1
                StealthOn(userid)
            else:
                Key['stealth on'] = 0
                StealthOff(userid)

#End Events 

#These handel all effects for user's powers
def SpawnEffects(userid):
    '''Handels what all the spawn powers user's have do'''
    Key = getPlayer(userid)
    Character = Characters[Key['Character']]
    #Set a user's cash based on their Resource dots
    Cash = 1500+(Character['Merrits']['Resources']**2)*300+((Character['Attributes']['Presence']-1)**2)*300
    es.setplayerprop(userid, "CCSPlayer.m_iAccount", Cash)
    #Sets a user's speed based on Strength, Dexterity, and Fleet of Foot Dots
    Speed(userid, (Character['Attributes']['Strength']-1)*.02)
    Speed(userid, (Character['Attributes']['Dexterity']-1)*.01)
    Speed(userid, (Character['Merrits']['Fleet of Foot'])*.03)
    Speed(userid, (Character['Skills']['Athletics']*.01))
    #Gives a user increased health based on Stamina Score
    Health(userid, (Character['Attributes']['Stamina']-1)**2*2)
    Health(userid, (Character['Attributes']['Presence']-1)**2)
    #Starts a regen loop for user's with Quick Healer and/or Werewolf Template
    Delayed(userid, 20, CheckAFK, userid)
    if 'Quick Healer' in Character['Merrits']:
        Regeneration(userid, 2, 1)
    if Character['Merrits']['Biokinesis']:
        biomenu.send(userid)
    if Character['Merrits']['Psyic Healer'] >= 3:
        Regeneration(userid, 2, 1)
    if Character['Template'] == 'Werewolf':
        Regeneration(userid, 2, 1)
    if Character['Skills']['Subterfuge']**2*3 >= random.randint(1, 100):
        es.tell(userid, '#multi', '#lightgreenYour subterfuge has allowed you to appear as the enemy.')
        Disguise(userid)
    if Character['Template'] == 'Vampire':
        Key['spawn location'] = es.getplayerlocation(userid)

def AttackerEffects(userid, victim, damage, weapon):
    '''Handels what all the attacker powers user's have do'''
    Key = getPlayer(userid)
    Key['shot fired'] = 1
    Character = Characters[Key['Character']]
    V_Key = getPlayer(victim)
    V_Character = Characters[Key['Character']]
    #Allows users to deal extra damage based on their buff key
    Damage(victim, userid, damage*Key['buff'])
    #Gives bonus damage based on Strength or Dexterity Dots
    if 'Fighting Finesse' not in Character['Merrits']:
        Damage(victim, userid, damage*(Character['Attributes']['Strength']-1)**2)
    else:
        Damage(victim, userid, damage*(Character['Attributes']['Dexterity']-1)**2)
    #Gives bonus damage based on Firearms skills
    if Character['Skills']['Firearms']:
        Damage(victim, userid, damage*(((Character['Skills']['Firearms']-1)**2)*(.01)+.01))
    if Character['Skills']['Stealth'] and Key['stealth on']:
        Damage(victim, userid, damage*(Character['Skills']['Stealth']*(.1)))
        StealthOff(userid)
        StealthDelay(userid)
    if Character['Skills']['Occult'] and V_Character['Template'] != 'Mortal':
        Damage(victim, userid, damage*.1)
        if Character['Skills']['Occult'] >= 2 and V_Character['Template'] != 'Vampire':
            es.server.queuecmd('est_Burn %s 4'%victim)
        if Character['Skills']['Occult'] >= 3 and V_Character['Template'] != 'Werewolf':
            Speed(victim, (damage*.25)*(-1))
        if Character['Skills']['Occult'] >= 5:
            if random.randint(1, 100) <= 20:
                Stun(victim, 2)

def VictimEffects(userid, attacker, damage, weapon):
    '''Handels all defensive powers user's have'''
    Key = getPlayer(userid)
    Character = Characters[Key['Character']]
    Scaling(userid, 'down')
    if Key['scaling stage'] == 0 and not Key['torpor state']:
        es.server.queuecmd('est_Fade %s 0 1 0 255 0 0 180'%userid)
    if Character['Skills']['Stealth'] and Key['stealth on']:
        StealthOff(userid)
        StealthDelay(userid)

#Pre events EST allows us to make things happen just before events fire (like hookind damage)
def prep_hurt():
    '''fires just before a user gets hurt'''
    userid = GetEVI('userid')
    attacker = GetEVI('attacker')
    damage = GetEVI('dmg_health')
    health = GetEVI('health')
    #es.msg('In prep hurt')
    if es.exists('userid', userid):
        #es.msg('userid exists')
        U_Key = getPlayer(userid)
        U_Character = Characters[U_Key['Character']]
        Dodged = 0
        Buffer(userid, damage, 'set')
        #es.msg(attacker)
        #es.msg(userid)
        #es.msg(U_Character['Template'])
        #es.msg('Health:  %s'%health)
        if attacker != userid:
            #es.msg('attacker != userid')
            if attacker:
                #es.msg('attacker true')
                A_Key = getPlayer(attacker)
                A_Character = Characters[A_Key['Character']]
                Buffer(userid, damage*A_Key['debuff'])
                VictimDex = U_Character['Attributes']['Dexterity']
                AttackerDex = A_Character['Attributes']['Dexterity']
                DodgeChance = (VictimDex-AttackerDex)*5
                if DodgeChance < 0:
                    DodgeChance = 0
                if U_Key['bio powers']['dodge']:
                    DodgeChance += U_Key['bio powers']['dodge']*5
                if U_Key['wolf form']:
                    DodgeChance += 40
                if 'Danager Sense' in U_Character['Merrits']:
                    DodgeChance += 5
                if U_Character['Skills']['Occult'] >= 4 and A_Character['Template'] != 'Mortal':
                    DodgeChance += 10
                #DodgeChance = 100
                #es.msg('Dodge Change %s '%DodgeChance)
                if DodgeChance >= random.randint(1, 100):
                    #es.msg('Dodged')
                    Dodged = 1
                    es.tell(userid, '#multi', '#defaultYou have dodged #lightgreen%s #defaultdamage from an attack'%damage)
                    Buffer(userid, damage)
                if not Dodged:
                    if 'Unseen Sense' in U_Character['Merrits']:
                        if A_Character['Template'] != 'Mortal':
                            if U_Key['unseen sense']:
                                Dodged = 1
                                U_Key['unseen sense'] = 0
                                Buffer(userid, damage)
                if not Dodged:
                    if U_Key['bio powers']['dr']:
                        Buffer(userid, damage*(U_Key['bio powers']['dr']*.07))
        if not Dodged and health < 1:
            if U_Character['Template'] == 'Vampire' and U_Key['torpor state'] == 0:
                if U_Key['spawn location'][0] or U_Key['spawn location'][1] or U_Key['spawn location'][2]:
                    SetEVI('health', U_Key['maxhealth'])
                    es.setplayerprop(userid, 'CBasePlayer.m_iHealth', U_Key['maxhealth'])
                    U_Key['torpor state'] = 1
                    U_Key['scaling stage'] = 0
                    es.server.queuecmd('est_DropWeapon %s 1'%userid)
                    es.server.queuecmd('est_DropWeapon %s 2'%userid)
                    es.server.queuecmd('est_Fade %s 0 1 3 255 255 255 255'%userid)
                    es.server.queuecmd('est_setplayercolor %s 255 255 255 255 1'%userid)
                    #es.msg(U_Key['spawn location'])
                    #es.msg(U_Key['spawn location'][0])
                    #es.msg(U_Key['spawn location'][1])
                    #es.msg(U_Key['spawn location'][2])
                    #location = es.getplayerlocation(userid)
                    #es.msg('Current Location: %s %s %s'%(location[0], location[1], location[2]))
                    #es.msg('es_xsetpos %s %s %s %s'%(userid, U_Key['spawn location'][0], U_Key['spawn location'][1], U_Key['spawn location'][2]))
                    es.server.queuecmd('es_xsetpos %s %s %s %s'%(userid, U_Key['spawn location'][0], U_Key['spawn location'][1], U_Key['spawn location'][2]))
                    #playerlib.getPlayer(userid).set('location', (U_Key['spawn location'][0], U_Key['spawn location'][1], U_Key['spawn location'][2]))
                    #es.setpos(userid, U_Key['spawn location'][0], U_Key['spawn location'][1], U_Key['spawn location'][2])
                    Freeze(userid, 10)
                    Delayed(userid, 10, UnTorpor, userid)

#Starting of Command Methods

def GiveXp(userid, amount, reason):
    '''Gives the given userid <amount> bonus to their current and total xp
    (Total xp is limmited to 200)'''
    Key = getPlayer(userid)
    ID = Bank(userid)
    Character = Characters[Key['Character']]
    if Character['total xp'] < 200:
        if Character['total xp']+amount < 200:
            Character['total xp'] += amount
            Character['xp'] += amount
            es.tell(userid, '#multi', '#defaultYou have %s and with that you have earned %s experience.'%(reason, amount))
        else:
            es.tell(userid, '#multi', '#defaultYou have %s and with that you have earned %s experience - You have now reached the maximum experience.'%(reason, Character['total xp']))
            Character['xp'] += 200-Character['total xp']
            Character['total xp'] += 200-Character['total xp']
    else:
        es.tell(userid, '#multi', '#defaultThis character has the maximum allowed experience.')

def Speed(userid, amount, set=None, delay=None):
    '''A command method used to manage user's speed
    There is an issue with using just the playerprop to store the value
    so a dict is used to track each player's speed'''
    Key = getPlayer(userid)
    if not set:
        Key['Speed'] += amount
    else:
        Key['Speed'] = amount
    es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", Key['Speed'])
    if delay:
        Delayed(userid, delay, Speed, (userid, amount*(-1)))

def Delayed(userid, duration, callback, args=()):
    '''Handels our delay calls so they cancel on user death/round end'''
    Key = getPlayer(userid)
    Key['delays'] += 1
    gamethread.delayedname(duration, '%s_%s'%(userid, Key['delays']), callback, args)

def Regeneration(userid, delay, amount, loops=None, currentloop=1):
    '''Excutes a looping heal command every X seconds'''
    if es.exists('userid', userid):
        Heal(userid, amount)
        if loops:
            if currentloop < loops:
                currentloop += 1
                Delayed(userid, delay, Regeneration, (userid, delay, amount, loops, currentloop))
        else:
            Delayed(userid, delay, Regeneration, (userid, delay, amount))

def Health(userid, amount, kind=None):
    '''Used to modify a user's max health'''
    Key = getPlayer(userid)
    if not kind:
        Key['maxhealth'] += amount
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', es.getplayerprop(userid, 'CBasePlayer.m_iHealth')+amount)
    else:
        Key['maxhealth'] = amount
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', amount)

def Heal(userid, amount, kind=None):
    '''Used to heal a user, meaning restore health up to their set max'''
    Key = getPlayer(userid)
    health = es.getplayerprop(userid, 'CBasePlayer.m_iHealth')
    if health+amount <= Key['maxhealth']:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', health+amount)
    else:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', Key['maxhealth'])
    Scaling(userid, 'up')

def Gravity(userid, amount, set=None):
    '''Used to track/modify a user's current gravity level'''
    Key = getPlayer(userid)
    if not set:
        Key['gravity'] += amount
    else:
        Key['gravity'] = amount
    es.server.queuecmd('est_setgravity %s %s'%(userid, Key['gravity']))

def Freeze(userid, duration=None):
    '''Used to stop a player from moving/shooting/turning'''
    Key = getPlayer(userid)
    Key['freeze'] += 1
    es.setplayerprop(userid, "CBasePlayer.m_fFlags", 32.0)
    if duration:
        Delayed(userid, duration, Unfreeze, userid)

def Unfreeze(userid):
    '''Restores a user's normal movement'''
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        if Key['freeze'] > 0:
            Key['freeze'] -= 1
        else:
            Key['freeze'] = 0
        if not Key['freeze']:
            es.setplayerprop(userid, "CBasePlayer.m_fFlags", 1)

def TempHealth(userid, amount, time=None):
    '''Gives said users a temporary health boost'''
    Health(userid, amount)
    if time:
        Delayed(userid, time, TempHealthOff, (userid,amount))

def TempHealthOff(userid, amount):
    '''Used to end a temp health boost'''
    if es.exists('userid', userid):
        if int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) > amount:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))-amount)
        else:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 1)
        getPlayer(userid)['maxhealth'] -= amount

def Stun(userid, duration=None):
    '''Used to stop a player from walking (can still shoot ect.)'''
    Key = getPlayer(userid)
    Key['stun'] += 1
    es.setplayerprop(userid, "CBaseEntity.movetype", 0)
    if duration:
        Delayed(userid, duration, Unstun, userid)

def Unstun(userid):
    '''Restores a player's normal movement'''
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        if Key['stun'] > 0:
            Key['stun'] -= 1
        else:
            Key['stun'] = 0
        if not Key['stun']:
            es.setplayerprop(userid, "CBaseEntity.movetype", 2)

def Disguise(userid, delay=None):
    '''Used to make a player appear as the enemy'''
    model = None
    if es.getplayerteam(userid) == 2:
        model = random.choice(['ct_urban','ct_sas','ct_gsg9','ct_gign'])
    else:
        model = random.choice(['t_phoenix','t_leet','t_guerilla','t_arctic'])
    if model:
        es.server.queuecmd('est_SetModel %s player/%s'%(userid, model))
        es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255 1'%userid)
    if delay:
        Delayed(userid, delay, Undisguise, userid)

def Undisguise(userid):
    '''Used to set a player's model to their teams'''
    if es.exists('userid', userid):
        model = None
        if es.getplayerteam(userid) == 2:
            model = random.choice(['t_phoenix','t_leet','t_guerilla','t_arctic'])
        else:
            model = random.choice(['ct_urban','ct_sas','ct_gsg9','ct_gign'])
        if model:
            es.server.queuecmd('est_SetModel %s player/%s'%(userid, model))
            es.server.queuecmd('est_SetPlayerColor %s 255 255 255 255 1'%userid)

def Damage(userid, attacker, damage):
    '''Used to cause damage between two users
    And is safe to call in player_hurt'''
    if es.getplayerprop(userid, 'CBasePlayer.m_iHealth') <= damage:
        es.server.queuecmd('damage %s %s 32 %s'%(userid, damage, attacker))
    else:
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', es.getplayerprop(userid, 'CBasePlayer.m_iHealth')-damage)
        Scaling(userid, 'down')

def Buff(userid, amount, duration=None):
    '''The value buff is linked to bonus damage user's'''
    Key = getPlayer(userid)
    Key['buff'] += amount
    if duration:
        Delayed(userid, duration, BuffOff, (userid, amount))

def BuffOff(userid, amount):
    '''Lowers the buff value, used when Buff() is called with a duration'''
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        Key['buff'] -= amount

def Debuff(userid, amount):
    '''Used to make a user cause less damage'''
    Key = getPlayer(userid)
    Key['debuff'] += amount

def Fade(userid,arg1,arg2,arg3,arg4,arg5,arg6,arg7):
    '''Used to fade a user's screen a different color
    Fade <userid> <0 = no fade, 1 = fade Out 2 = fade in> <time to fade (in frames)> <time faded (in frames)> <red> <green> <blue> <alpha>'''
    if es.exists('userid',userid):
        es.usermsg('create','fade','Fade')
        es.usermsg('write','short','fade',arg2)
        es.usermsg('write','short','fade',arg3)
        es.usermsg('write','short','fade',arg1)
        es.usermsg('write','byte','fade',arg4)
        es.usermsg('write','byte','fade',arg5)
        es.usermsg('write','byte','fade',arg6)
        es.usermsg('write','byte','fade',arg7)
        es.usermsg('send','fade',userid)
        es.usermsg('delete','fade')

def HudHint(userid, msg):
    '''Displays the given message to users at the bottom of their screen'''
    es.usermsg('create','hudhint','HintText')
    es.usermsg('write','short','hudhint',-1)
    es.usermsg('write','string','hudhint',msg)
    es.usermsg('send','hudhint',userid)
    es.usermsg('delete','hudhint')

def Bank(userid):
    '''Stores the only long term information for each player, contains each person's character list based on steamid
    returns each user's long term key'''
    userid = int(userid)
    steamid = playerlib.uniqueid(userid)
    if es.exists('userid', userid):
        if steamid not in IDStorage:
            IDStorage[steamid] = []
        return IDStorage[steamid]

def Default(userid):
    '''Sets all of a user's values to defaults'''
    Key = getPlayer(userid)
    Character = Characters[Key['Character']]
    Key['Speed'] = 1.0
    Key['freeze'] = 0
    Key['stun'] = 0
    Key['delays'] = 0
    Key['gravity'] = 1.0
    Key['maxhealth'] = 100
    Key['jump'] = 1.0+(Character['Skills']['Athletics']**2)*.01
    Key['buff'] = 0
    Key['debuff'] = 0
    Key['buffer'] = 0
    Key['unseen sense'] = 1
    Key['sprint max'] = 4.5+(Character['Skills']['Athletics']/2)+(Character['Attributes']['Stamina']/2)
    Key['sprint'] = 4.5+(Character['Skills']['Athletics']/2)+(Character['Attributes']['Stamina']/2)
    Key['sprint on'] = 0
    Key['stealth on'] = 0
    Key['stealth delay'] = 0
    Key['scaling stage'] = 0
    Key['spawn location'] = [0,0,0]
    Key['torpor state'] = 0
    Key['wolf form'] = 0
    Key['bio points'] = 0
    Key['bio powers'] = {'health':0, 'regen':0, 'dr':0, 'dodge':0, 'speed':0}

def getPlayer(userid):
    '''Returns the user key of a given player, teporary storage never saved'''
    userid = int(userid)
    if es.exists('userid', userid):
        if userid not in Users:
            Users[userid] = {   'Character':None,
                                'Speed':1.0,
                                'shot fired':0,
                                'freeze':0,
                                'stun':0,
                                'delays':0,
                                'gravity':1.0,
                                'maxhealth':100,
                                'jump':1.0,
                                'buff':0,
                                'debuff':0,
                                'buffer':0,
                                'unseen sense':1,
                                'sprint':5.0,
                                'sprint max':5.0,
                                'sprint on':0,
                                'stealth on':0,
                                'stealth delay':0,
                                'scaling stage':0,
                                'spawn location':[0,0,0],
                                'torpor state':0,
                                'wolf form':0,
                                'bio points':0,
                                'bio powers':{'health':0, 'regen':0, 'dr':0, 'dodge':0, 'speed':0}}
            if es.isbot(userid):
                Users[userid]['Character'] = 'BOT'
    #es.msg('Character: %s'%Users[userid]['Character'])
        return Users[userid]

#End of Command Methods

#The methods that control stealth

def StealthOn(userid):
    '''Used to turn stealth on for users'''
    Key = getPlayer(userid)
    Character = Characters[Key['Character']]
    if not Key['stealth delay'] and not Key['torpor state']:
        if Character['Skills']['Stealth']:
            Color = 115
            Color -= Character['Skills']['Stealth']**2*2
            Color -= Character['Attributes']['Dexterity']**2*2
            es.tell(userid, '#multi', '#lightgreenYou have gone into stealth mode.')
            es.server.queuecmd('est_setplayercolor %s 255 255 255 %s 1'%(userid, Color))

def StealthOff(userid):
    '''Used to turn stealth off for users'''
    Key = getPlayer(userid)
    Character = Characters[Key['Character']]
    if Character['Skills']['Stealth']:
        if not Key['stealth delay']:
            es.tell(userid, '#multi', '#lightgreenYou have come out of your stealth.')
        es.server.queuecmd('est_setplayercolor %s 255 255 255 255 1'%(userid))

def StealthDelay(userid):
    '''Used to turn stealth off for a set timer'''
    Key = getPlayer(userid)
    Key['stealth delay'] += 1
    Delayed(userid, 3, StealthReady, userid)

def StealthReady(userid):
    '''Used to let a user restealth'''
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        Character = Characters[Key['Character']]
        Key['stealth delay'] -= 1
        if not Key['stealth delay']:
            if Key['stealth on']:
                StealthOn(userid)
            else:
                if Character['Skills']['Stealth']:
                    es.tell(userid, '#multi', '#lightgreenYou are ready to go into stealth again.')

#The Methods that control sprinting

def SprintOn():
    '''Runs when a user press the sprint key'''
    userid = es.getcmduserid()
    Key = getPlayer(userid)
    if Key['sprint'] == Key['sprint max']:
        if not Key['stealth on'] and not Key['wolf form']:
            Key['sprint on'] = 1
            Speed(userid, .15)
            Sprinting(userid)
        else:
            es.tell(userid, '#multi', '#greenYou cannot sprint while stealthed!')

def SprintOff():
    '''Runs when a user releases the sprint key'''
    userid = es.getcmduserid()
    Key = getPlayer(userid)
    Key['sprint on'] = 0

def Sprinting(userid):
    '''Handels the user key up/down and whether to speed up or slow down'''
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        if Key['sprint on']:
            if Key['sprint'] > 0:
                HudHint(userid, 'Sprinting %s'%Key['sprint'])
                Key['sprint'] -= .5
                Delayed(userid, .5, Sprinting, userid)
            else:
                Speed(userid, -.35)
                Delayed(userid, .5, SprintCharge, userid)
        else:
            Speed(userid, -.35)
            Delayed(userid, .5, SprintCharge, userid)

def SprintCharge(userid):
    '''Recharges a user's sprint value'''
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        HudHint(userid, 'Resting %s'%Key['sprint'])
        Key['sprint'] += .25
        if Key['sprint'] < Key['sprint max']:
            Delayed(userid, .5, SprintCharge, userid)
        else:
            Speed(userid, .2)
            HudHint(userid, '')

#A few core methods to the program

def Command():
    '''Handels what happens when ever a user puts "wod" in chat or console'''
    userid = str(es.getcmduserid())
    if es.exists('userid', userid):
        steamid = playerlib.uniqueid(userid)
        Key = getPlayer(userid)
        ID = Bank(userid)
        arg1 = es.getargv(1).lower()
        argcount = es.getargc()
        stringcount = 2
        commandstring = ''
        while stringcount <= argcount:
            addstring = es.getargv(stringcount)
            commandstring = '%s %s'%(commandstring, addstring)
            stringcount += 1
        commandstring.strip()
        if arg1 == 'create':
            if commandstring and commandstring != ' ':
                CreateCharacter(userid, commandstring)
            else:
                es.tell(userid, '#multi', '#defaultInput the name of the character you wish to create.')
                inputlib.InputChecker(userid).chatbox(30, 'wod create', 'create character')
        elif arg1 == 'load':
            if es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
                if commandstring and commandstring != ' ':
                    LoadCharacter(userid, commandstring)
                else:
                    loadmenu.send(userid)
            else:
                es.tell(userid, '#multi', '#defaultYou must be dead to create a new character.')
        elif arg1 == 'del':
            if commandstring and commandstring != ' ':
                #es.msg(ID)
                if commandstring in ID:
                    es.tell(userid, '#multi', '#defaultThe character #green%s #defaulthas been removed from memory.'%ID[ID.index(commandstring)])
                    del Characters[commandstring]
                    ID.remove(commandstring)
                else:
                    es.tell(userid, '#multi', '#defaultThe character #green%s #defaultis not in your character list!'%commandstring)
            else:
                delmenu.send(userid)
        elif arg1 == 'default':
            if commandstring and commandstring != ' ':
                if commandstring in ID:
                    ID.remove(commandstring)
                    ID.insert(commandstring, 0)
                    es.tell(userid, '#multi', '#green%s #defaultis now loaded by default when you join the server.'%commandstring)
                else:
                    es.tell(userid, '#multi', '#defaultSorry but #green%s #defaultis not a character you have.'%commandstring)
            else:
                ID.remove(Key['Character'])
                ID.insert(0, Key['Character'])
                es.tell(userid, '#multi', '#green%s #defaultis now loaded by default when you join the server.'%Key['Character'])
        elif arg1 == 'menu':
            mainmenu.send(userid)
        elif arg1 == 'help':
            welcomemenu.send(userid)
        elif arg1 == 'info':
            infomenu.send(userid)
        elif arg1 == 'xp':
            xpmenu.send(userid)
        elif arg1 == 'stats':
            statmenu.send(userid)
        elif arg1 == 'wolf':
            Character = Characters[Key['Character']]
            if Character['Template'] == 'Werewolf':
                if not Key['wolf form']:
                    Speed(userid, .5)
                    Health(userid, 75)
                    es.server.queuecmd('est_DropWeapon %s 1'%userid)
                    es.server.queuecmd('est_DropWeapon %s 2'%userid)
                    es.server.queuecmd('est_setplayercolor %s 0 0 0 255 1'%userid)
                    Key['wolf form'] = 1
                    es.tell(userid, '#multi', '#defaultYou have gone into wolf form.')
                else:
                    Speed(userid, -.5)
                    TempHealthOff(userid, 75)
                    es.server.queuecmd('est_setplayercolor %s 255 255 255 255 1'%userid)
                    Key['wolf form'] = 0
                    es.tell(userid, '#multi', '#defaultYou appear human again.')
        elif arg1 == 'heal':
            Character = Characters[Key['Character']]
            if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
                if Character['Merrits']['Psyic Healer'] == 5:
                    if es.getplayerprop(userid, 'CBasePlayer.m_iHealth') > 10:
                        es.ServerVar('_temp_target').set(0)
                        es.server.queuecmd('est_getviewplayer %s _temp_target'%userid)
                        gamethread.delayed(.1, healRun, (userid))
        '''elif arg1 == 'debug':
            es.tell(userid, '#default', 'Characters:')
            for Character in Characters:
                es.tell(userid, '#lightgreen', Character)
            es.tell(userid, '#default', 'User Bank')
            ID = Bank(userid)
            for Character in ID:
                es.tell(userid, '#lightgreen', Character)'''

def CreateCharacter(userid, Name):
    '''Handels creating new characters for all players'''
    steamid = playerlib.uniqueid(userid)
    ID = Bank(userid)
    Key = getPlayer(userid)
    if len(ID) < 8:
        if Name not in Characters:
            Characters[Name] = {'Template':'Mortal',
                                'Merrits':{     'Resources':0,
                                                'Fleet of Foot':0,
                                                'Biokinesis':0,
                                                'Psyic Healer':0,
                                                'Iron Stamina':0},
                                'Attributes':{  'Strength':1,
                                                'Dexterity':1,
                                                'Stamina':1,
                                                'Presence':1},
                                'Skills':{      'Athletics':0,
                                                'Firearms':0,
                                                'Stealth':0,
                                                'Larceny':0,
                                                'Subterfuge':0,
                                                'Occult':0},
                                'Merrit Lists':{1:[]},
                                'xp': 25.0,
                                'total xp': 25.0,
                                'creator':steamid}
            if es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
                ID.insert(0, Name)
                Key['Character'] = Name
            else:
                ID.append(Name)
            es.tell(userid, '#multi', '#lightgreen%s #defaulthas been created! You have #green25 #defaultdefault xp to spend.'%Name)
        else:
            es.cexec(userid, 'wod create %s %s'%(Name.strip(), random.choice(sufixes)))
    else:
        es.tell(userid, '#multi', '#defaultYou cannot create more than 8 characters!')

def LoadCharacter(userid, Name):
    '''Handels loading the given character from the Character DB to the user'''
    steamid = playerlib.uniqueid(userid)
    ID = Bank(userid)
    if Name in ID:
        Key = getPlayer(userid)
        Key['Character'] = Name
        ID.remove(Key['Character'])
        ID.insert(0, Key['Character'])
        es.tell(userid, '#multi', '#lightgreen%s #defaulthas been loaded.'%Name)
    else:
        if Name in Characters:
            es.tell(userid, '#multi', '#defaultSorry but #lightgreen%s #defaultis someone else\'s character.'%Name)
        else:
            es.tell(userid, '#multi', '#defaultSorry but #lightgreen%s #defaultdoes not exist! Use #greenwod create #defaultto create this character.'%Name)

'''Misc Methods'''

def WrongMenu():
    '''Runs when ever a user enters a menu command common for another mod'''
    userid = es.getcmduserid()
    es.tell(userid, '#multi', '#lightgreen%s #defaultwas entered... Please use #greenwod menu #defaultfrom now on.'%(es.getargv(0)))
    es.cexec(userid, 'wod menu')

def CheckAFK(userid):
    '''Run 20 seconds after a player spawns, if they are within 10 units of their spawning location they are considered IDLE'''
    if es.exists('userid', userid):
        x,y,z = es.getplayerlocation(userid)
        Key = getPlayer(userid)
        if not Key['torpor state'] and not Key['shot fired']:
            x1,y1,z1 = Key['spawn location']
            if math.sqrt((x-x1)**2+(y-y1)**2+(z-z1)**2) <= 10:
                es.server.queuecmd('es_xchangeteam %s 1'%userid)
                es.msg('- %s has been IDLE at spawn for 20 seconds and has been forced to spectator -'%es.getplayername(userid))

def UnTorpor(userid):
    '''Used to set a player back to out of torpor'''
    if es.exists('userid', userid):
        Key = getPlayer(userid)
        es.server.queuecmd('est_Fade %s 0 1 0 255 255 255 0'%userid)
        Key['torpor state'] = 0

def healRun(userid):
    '''The command code for wod heal'''
    target = int(es.ServerVar('_temp_target'))
    if target and target != userid:
        if Characters[getPlayer(userid)['Character']]['Merrits']['Psyic Healer'] < 5:
            es.tell(userid, '#multi', '#defaultYou have restored some health to #lightgreen%s'%es.getplayername(target))
            es.tell(userid, '#multi', '#lightgreen%s #defaulthas begun regenerating your wounds.'%es.getplayername(userid))
            Damage(userid, userid, 10)
            Regeneration(target, 1, 3, 10)

def BotLoad():
    '''Loads the bot character key into memory'''
    if 'BOT' not in Characters:
        Characters['BOT'] = {'Template':'Mortal',
                                'Merrits':{     'Resources':3,
                                                'Fleet of Foot':2,
                                                'Biokinesis':0,
                                                'Psyic Healer':0,
                                                'Iron Stamina':3,
                                                'Quick Healer':4,
                                                'Unseen Sense':3},
                                'Attributes':{  'Strength':3,
                                                'Dexterity':2,
                                                'Stamina':4,
                                                'Presence':1},
                                'Skills':{      'Athletics':0,
                                                'Firearms':3,
                                                'Stealth':0,
                                                'Larceny':0,
                                                'Subterfuge':0,
                                                'Occult':4},
                                'Merrit Lists':{1:[]},
                                'xp': 0,
                                'total xp': 200,
                                'creator':None}

def FadeLoop():
    '''Loops every 3 seconds to fade user's based on health'''
    for userid in es.getUseridList():
        if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
            Key = getPlayer(userid)
            FadeLevel = 0
            if Key['scaling stage'] == 1:
                FadeLevel = 100
            elif Key['scaling stage'] == 2:
                FadeLevel = 140
            elif Key['scaling stage'] == 3:
                FadeLevel = 180
            if not Key['torpor state']:
                es.server.queuecmd('est_Fade %s 0 1 3 255 0 0 %s'%(userid, FadeLevel))
            else:
                es.server.queuecmd('est_Fade %s 0 1 3 255 255 255 255'%(userid))
    gamethread.delayedname(3, 'wod_Fade', FadeLoop)

def Scaling(userid, kind):
    '''Sets up a user's scaling damage and health'''
    Key = getPlayer(userid)
    Character = Characters[Key['Character']]
    health = es.getplayerprop(userid, 'CBasePlayer.m_iHealth')
    if kind == 'down':
        if health < 15 and Key['scaling stage'] == 2:
            Key['scaling stage'] = 3
            if Character['Merrits']['Iron Stamina']  < 3:
                Speed(userid, -.1)
                Debuff(userid, .1)
            es.server.queuecmd('est_Fade %s 0 1 3 255 0 0 180'%(userid))
        elif health < 30 and Key['scaling stage'] == 1:
            Key['scaling stage'] = 2
            if Character['Merrits']['Iron Stamina']  < 2:
                Speed(userid, -.1)
                Debuff(userid, .1)
            Scaling(userid, kind)
            es.server.queuecmd('est_Fade %s 0 1 3 255 0 0 140'%(userid))
        elif health < 45 and Key['scaling stage'] == 0:
            Key['scaling stage'] = 1
            if Character['Merrits']['Iron Stamina']  < 1:
                Speed(userid, -.1)
                Debuff(userid, .1)
            Scaling(userid, kind)
            es.server.queuecmd('est_Fade %s 0 1 3 255 0 0 100'%(userid))
    elif kind == 'up':
        if health > 45 and Key['scaling stage'] == 1:
            Key['scaling stage'] = 0
            if Character['Merrits']['Iron Stamina']  < 1:
                Speed(userid, .1)
                Debuff(userid, -.1)
            Scaling(userid, kind)
            es.server.queuecmd('est_Fade %s 0 1 3 255 0 0 0'%(userid))
        elif health > 30 and Key['scaling stage'] == 2:
            Key['scaling stage'] = 1
            if Character['Merrits']['Iron Stamina']  < 2:
                Speed(userid, .1)
                Debuff(userid, -.1)
            Scaling(userid, kind)
            es.server.queuecmd('est_Fade %s 0 1 3 255 0 0 100'%(userid))
        elif health > 15 and Key['scaling stage'] == 3:
            Key['scaling stage'] = 2
            if Character['Merrits']['Iron Stamina']  < 3:
                Speed(userid, .1)
                Debuff(userid, -.1)
            Scaling(userid, kind)
            es.server.queuecmd('est_Fade %s 0 1 3 255 0 0 140'%(userid))

def GetEVI(einfo):
    '''Wraps up having to turn GEI into local python vars'''
    es.ServerVar('_temp_var').set(0)
    es.server.cmd('est_GetEventInfo _temp_var %s'%einfo)
    try:
        return int(es.ServerVar('_temp_var'))
    except:
        return str(es.ServerVar('_temp_var'))

def SetEVI(einfo, value):
    '''To make setting EVIs pretty'''
    es.server.queuecmd('est_SetEventInfo %s %s'%(einfo, value))

def Buffer(userid, amount, set=None):
    '''Used to help track how much damage we hook from each attack
    This way attacks will never "heal" users'''
    Key = getPlayer(userid)
    if not set and Key['buffer']:
        if Key['buffer'] >= amount:
            Key['buffer'] -= amount
            #es.msg('%s Health:'%es.getplayername(userid))
            #es.msg('Pre Buffer: %s'%es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))
            #es.msg('Amount: %s'%amount)
            SetEVI('dmg_health', GetEVI('dmg_health')-amount)
            SetEVI('health', GetEVI('health')+amount)
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', es.getplayerprop(userid, 'CBasePlayer.m_iHealth')+amount)
            #es.msg('Post Buffer: %s'%es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))
        else:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', es.getplayerprop(userid, 'CBasePlayer.m_iHealth')+Key['buffer'])
            SetEVI('dmg_health', GetEVI('dmg_health')-Key['buffer'])
            SetEVI('health', GetEVI('health')+Key['buffer'])
            Key['buffer'] = 0
    elif set:
        Key['buffer'] = amount

#A few cheesy effects
def Beam(player1,player2,life,r,g,b):
    #Sends a random beam connecting the two players with the given RGB color values
    choice = random.randint(1, 2)
    if choice == 1:
        Beam1(player1,player2,life,r,g,b)
    #Didnt like how this beam looks
    #elif choice == 2:
    #    Beam2(player1,player2,life,r,g,b)
    elif choice == 2:
        Beam3(player1,player2,life,r,g,b)
def Beam1(player1,player2,life,r,g,b):
    # Connects 2 users together via a normal beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = es.getplayerlocation(player2)
    es.server.queuecmd('est_effect 3 #a 0 sprites/lgtning.vmt %s %s %s %s %s %s %s 40 10 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))
def Beam2(player1,player2,life,r,g,b):
    # Connects 2 users together via a more rough beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = es.getplayerlocation(player2)
    es.server.queuecmd('est_effect 3 #a 0 effects/tp_eyefx/tpeye3.vmt %s %s %s %s %s %s %s 7 3 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))
def Beam3(player1,player2,life,r,g,b):
    # Connects 2 users together via a laser beam
    x,y,z = es.getplayerlocation(player1)
    x1,y1,z1 = es.getplayerlocation(player2)
    es.server.queuecmd('est_effect 3 #a 0 materials/sprites/laser.vmt %s %s %s %s %s %s %s 40 10 %s %s %s 255'%(x,y,z + 30,x1,y1,z1 + 30,life,r,g,b))

'''From here on out it is all code to power the menus...
    Alot I know!'''

def BioMenuPrep(userid, popupid):
    '''Gives a user with the biokinesis skill a menu to select powers from'''
    Key = getPlayer(userid)
    Character = Characters[Key['Character']]
    popup = popuplib.find(popupid)
    '''es.msg(type(Character['Merrits']['Biokinesis']))
    es.msg(Character['Merrits']['Biokinesis'])
    es.msg(type(Key['bio points']))
    es.msg(Key['bio points'])'''
    popup.modline(2, '- Points Remaining - %s -'%str(Character['Merrits']['Biokinesis']-Key['bio points']))
    if Key['bio powers']['health'] < 3:
        popup.modline(3, '-> 1. Bonus Health (%s)'%Key['bio powers']['health'])
    else:
        popup.modline(3, 'MAX Bonus Health (3)')
    if Key['bio powers']['speed'] < 5:
        popup.modline(4, '-> 2. Bonus Speed (%s)'%Key['bio powers']['speed'])
    else:
        popup.modline(4, 'MAX Bonus Speed (5)')
    if Key['bio powers']['regen'] < 1:
        popup.modline(5, '-> 3. Regeneration')
    else:
        popup.modline(5, 'MAX Regeneration')
    if Key['bio powers']['dodge'] < 2:
        popup.modline(6, '-> 4. Increased Dodging (%s)'%Key['bio powers']['dodge'])
    else:
        popup.modline(6, 'MAX Increased Dodging (2)')
    if Key['bio powers']['dr'] < 3:
        popup.modline(7, '-> 5. Damage Reduction (%s)'%Key['bio powers']['dr'])
    else:
        popup.modline(7, 'MAX Damage Reduction (3)')

def BioMenuSelect(userid, choice, popupid):
    '''Runs when a user selects an option on bio menu'''
    Key = getPlayer(userid)
    Power = BioMenuKey[choice]
    Max = BioMenuMax[Power]
    if Key['bio powers'][Power] < Max:
        Key['bio points'] += 1
        Key['bio powers'][Power] += 1
        if Power == 'regen':
            Regeneration(userid, 4, 1)
        elif Power == 'speed':
            Speed(userid, .03)
        elif Power == 'health':
            Health(userid, 5)
    if Key['bio points'] < Characters[Key['Character']]['Merrits']['Biokinesis']:
        biomenu.send(userid)

'''The key used to link which powers are which choices'''
BioMenuKey = {  1:'health',
                3:'regen',
                5:'dr',
                4:'dodge',
                2:'speed'}
BioMenuMax = {  'health':3,
                'regen':1,
                'dodge':2,
                'dr':3,
                'speed':3}

def SkillsBuyPrep(userid, popupid):
    '''Runs just before a user selects the skills to purchase menu, to prep if for each user'''
    Key = getPlayer(userid)
    ID = Bank(userid)
    Character = Characters[Key['Character']]
    popup = popuplib.find(popupid)
    if popupid == 'skill buy':
        for skill in Character['Skills']:
            modL = SkillLineKey[popupid][skill]
            if Character['Skills'][skill] < 5:
                if Character['Skills'][skill] > 0:
                    popup.modline(modL, '-> %s. %s (Dots: %s)'%(modL-1, skill, Format(Character['Skills'][skill]+1)))
                else:
                    popup.modline(modL, '-> %s. %s (Dot: O)'%(modL-1, skill))
            else:
                popup.modline(modL, 'MAX %s (Dots: OOOOO)'%(skill))

#Links which skills are in which lines for the skill buy menu
SkillLineKey = {    'skill buy':{   'Athletics':2,
                                    'Firearms':3,
                                    'Stealth':4,
                                    'Larceny':5,
                                    'Subterfuge':6,
                                    'Occult':7}}

def SkillsBuySelect(userid, choice, popupid):
    '''Is run when a user selects a skill from the skills purchase menu'''
    if choice < 9:
        choice = SkillChoiceKey[popupid][choice]
        Key = getPlayer(userid)
        ID = Bank(userid)
        Character = Characters[Key['Character']]
        if Character['Skills'][choice] < 5:
            if Character['xp'] >= (Character['Skills'][choice]+1)*3:
                Character['xp'] -= (Character['Skills'][choice]+1)*3
                Character['Skills'][choice] += 1
                es.tell(userid, '#multi', '#defaultYou have gained a dot in your #lightgreen%s #defaultskill'%choice)
            else:
                es.tell(userid, '#multi', '#defaultI am sorry but you do not have enough experience to gain a dot in %s.'%choice)
        else:
            es.tell(userid, '#multi', '#defaultI am sorry but you already have max dots in %s.'%choice)

#Links which choice from the popup menu is which skill
SkillChoiceKey = {  'skill buy':{   1:'Athletics',
                                    2:'Firearms',
                                    3:'Stealth',
                                    4:'Larceny',
                                    5:'Subterfuge',
                                    6:'Occult'}}

def AttBuyPrep(userid, popupid):
    '''Runs just before a user selects the att upgrade menu'''
    Key = getPlayer(userid)
    ID = Bank(userid)
    Character = Characters[Key['Character']]
    popup = popuplib.find(popupid)
    if Character['Attributes']['Strength'] < 5:
        popup.modline(2, '-> 1. Strength (Dots: %s)'%Format(Character['Attributes']['Strength']+1))
    else:
        popup.modline(2, ' MAX Strength (Dots: OOOOO)')
    if Character['Attributes']['Dexterity'] < 5:
        popup.modline(3, '-> 2. Dexterity (Dots: %s)'%Format(Character['Attributes']['Dexterity']+1))
    else:
        popup.modline(3, ' MAX Dexterity (Dots: OOOOO)')
    if Character['Attributes']['Stamina'] < 5:
        popup.modline(4, '-> 3. Stamina (Dots: %s)'%Format(Character['Attributes']['Stamina']+1))
    else:
        popup.modline(4, ' MAX Stamina (Dots: OOOOO)')
    if Character['Attributes']['Presence'] < 5:
        popup.modline(5, '-> 4. Presence (Dots: %s)'%Format(Character['Attributes']['Presence']+1))
    else:
        popup.modline(5, ' MAX Presence (Dots: OOOOO)')

def AttBuySelect(userid, choice, popupid):
    '''Runs when a user selects an option from the att buy'''
    Key = getPlayer(userid)
    ID = Bank(userid)
    Character = Characters[Key['Character']]
    popup = popuplib.find(popupid)
    if choice < 9:
        att = AttBuyKey[choice]
        if Character['Attributes'][att] < 5:
            if Character['xp'] >= ((Character['Attributes'][att]+1)*5):
                Character['Attributes'][att] += 1
                Character['xp'] -= Character['Attributes'][att]*5
                es.tell(userid, '#multi', '#defaultYour %s has advanced to dots #lightgreen%s'%(att, Format(Character['Attributes'][att])))
            else:
                es.tell(userid, '#multi', '#defaultYou do not have enough xp to advance your %s'%att)
        else:
            es.tell(userid, '#multi', '#defaultYour %s is already maxed'%att)

#Links which menu choice is which Attribute
AttBuyKey = {   1:'Strength',
                2:'Dexterity',
                3:'Stamina',
                4:'Presence'}

def MerritBuyPrep(userid, popupid):
    '''Runs just before a user selects the merrits to purchase menu, to prep if for each user'''
    Key = getPlayer(userid)
    ID = Bank(userid)
    Character = Characters[Key['Character']]
    popup = popuplib.find(popupid)
    if popupid == "merrit buy":
        if Character['Merrits']['Resources'] < 5:
            dots = Format(Character['Merrits']['Resources']+1)
            popup.modline(2, '-> 1. Resources (Dots: %s)'%dots)
        else:
            popup.modline(2, 'MAX Resources (Dots: OOOOO)')
        if 'Fighting Finesse' not in Character['Merrits']:
            if Character['Attributes']['Dexterity'] >= 3:
                popup.modline(3, '-> 2. Fighting Finesse (Dots: OOO)')
            else:
                popup.modline(3, ' Fighting Finesse (Requires: Dexterity OOO)')
        else:
            popup.modline(3, 'MAX Fighting Finesse (Dots: OOO)')
        if 'Quick Healer' not in Character['Merrits']:
            if Character['Attributes']['Stamina'] >= 4:
                popup.modline(4, '-> 3. Quick Healer (Dots: OOOO)')
            else:
                popup.modline(4, ' Quick Healer (Requires: Stamina OOOO)')
        else:
            popup.modline(4, 'MAX Quick Healer (Dots: OOOO)')
        if 'Unseen Sense' not in Character['Merrits']:
            popup.modline(5, '-> 4. Unseen Sense (Dots: OOO)')
        else:
            popup.modline(5, 'MAX Unseen Sense (Dots: OOO)')
        if Character['Merrits']['Fleet of Foot'] < 3:
            if Character['Merrits']['Fleet of Foot'] > 0:
                dots = Format(Character['Merrits']['Fleet of Foot']+1)
                popup.modline(6, '-> 5. Fleet of Foot (Dots: %s)'%dots)
            else:
                popup.modline(6, '-> 5. Fleet of Foot (Dot: O)')
        else:
            popup.modline(6, 'MAX Fleet of Foot (Dots: OOO)')
    elif popupid == 'merrit buy2':
        if 'Danger Sense' not in Character['Merrits']:
            popup.modline(2, '-> 1. Danger Sense (Dots: OO)')
        else:
            popup.modline(2, 'MAX Danger Sense (Dots: OO)')
        if Character['Merrits']['Biokinesis'] < 5:
            if Character['Template'] == 'Psion':
                dots = Format(Character['Merrits']['Biokinesis']+1)
                popup.modline(3, '-> 2. Biokinesis (Dots: %s)'%dots)
            else:
                popup.modline(3, ' Biokinesis (Requires: Psion)')
        else:
            popup.modline(3, 'MAX Biokinesis (Dots: OOOOO)')
        if Character['Merrits']['Psyic Healer'] < 5:
            if Character['Template'] == 'Psion':
                if Character['Merrits']['Psyic Healer'] == 3:
                    popup.modline(4, '-> 3. Psyic Healer (Dots: OOOOO)')
                else:
                    popup.modline(4, '-> 3. Psyic Healer (Dots: OOO)')
            else:
                popup.modline(4, ' Psyic Healer (Requires: Psion)')
        else:
            popup.modline(4, 'MAX Psyic Healer (Dots: OOOOO)')
        if Character['Merrits']['Iron Stamina'] < 3:
            dots = Character['Merrits']['Iron Stamina']+1
            if Character['Attributes']['Stamina'] >= dots:
                popup.modline(5, '-> 4. Iron Stamina (Dots: %s)'%Format(dots))
            else:
                popup.modline(5, ' Iron Stamina (Requires: Stamina %s)'%Format(dots))
        else:
            popup.modline(5, 'MAX Iron Stamina (Dots: OOO)')

def MerritBuySelect(userid, choice, popupid):
    '''Is run when a user selects something other than forward or backwards from a merrit buy menu'''
    if choice < 8:
        Key = getPlayer(userid)
        ID = Bank(userid)
        Character = Characters[Key['Character']]
        if popupid == 'merrit buy':
            if choice == 1 or choice == 5:
                if Character['Merrits'][MultiMerritKey[popupid][choice]] < MultiMerritMax[popupid][choice]:
                    if Character['xp'] >= (Character['Merrits'][MultiMerritKey[popupid][choice]]+1)*2:
                        AddMerrit(userid, MultiMerritKey[popupid][choice])
                        Character['xp'] -= (Character['Merrits'][MultiMerritKey[popupid][choice]]+1)*2
                        Character['Merrits'][MultiMerritKey[popupid][choice]] += 1
                        es.tell(userid, '#multi', '#defaultYou have gained dot #lightgreen%s #defaultinto #green%s'%(Format(Character['Merrits'][MultiMerritKey[popupid][choice]]), MultiMerritKey[popupid][choice]))
                    else:
                        es.tell(userid, '#multi', '#defaultYou do not have enough experience to gain a dot of %s'%MultiMerritKey[popupid][choice])
                else:
                    es.tell(userid, '#multi', '#defaultYour %s is already at max dots!'%MultiMerritKey[popupid][choice])
            elif choice == 2:
                if Character['Attributes']['Dexterity'] >= 3:
                    if 'Fighting Finesse' not in Character['Merrits']:
                        if Character['xp'] >= 6:
                            Character['Merrits']['Fighting Finesse'] = 3
                            Character['xp'] -= 6
                            AddMerrit(userid, 'Fighting Finesse')
                            es.tell(userid, '#multi', '#defaultYou have gained the #greenFighting Finesse #defaultmerrit.')
                        else:
                            es.tell(userid, '#multi', '#defaultYou do not have enough experience to gain Fighting Finesse')
                    else:
                        es.tell(userid, '#multi', '#defaultYou already have Fighting Finesse')
                else:
                    es.tell(userid, '#multi', '#defaultYou do not have enough Dexterity to gain Fighting Finesse')
            elif choice == 3:
                if Character['Attributes']['Stamina'] >= 4:
                    if 'Quick Healer' not in Character['Merrits']:
                        if Character['xp'] >= 8:
                            Character['Merrits']['Quick Healer'] = 4
                            Character['xp'] -= 8
                            AddMerrit(userid, 'Quick Healer')
                            es.tell(userid, '#multi', '#defaultYou have gained the #greenQuick Healer #defaultmerrit.')
                        else:
                            es.tell(userid, '#multi', '#defaultYou do not have enough experience to gain Quick Healer')
                    else:
                        es.tell(userid, '#multi', '#defaultYou already have Quick Healer')
                else:
                    es.tell(userid, '#multi', '#defaultYou do not have enough Stamina to gain Quick Healer')
            elif choice == 4:
                if Character['Template'] == 'Mortal':
                    if 'Unseen Sense' not in Character['Merrits']:
                        if Character['xp'] >= 6:
                            Character['Merrits']['Unseen Sense'] = 3
                            Character['xp'] -= 6
                            AddMerrit(userid, 'Unseen Sense')
                            es.tell(userid, '#multi', '#defaultYou have gained the #greenUnseen Sense #defaultmerrit.')
                        else:
                            es.tell(userid, '#multi', '#defaultYou do not have enough experience to gain Unseen Sense')
                    else:
                        es.tell(userid, '#multi', '#defaultYou already have Unseen Sense')
                else:
                    es.tell(userid, '#multi', '#defaultYou must be a mortal to gain Unseen Sense')
        elif popupid == 'merrit buy2':
            if choice == 2 or choice == 4:
                if Character['Merrits'][MultiMerritKey[popupid][choice]] < MultiMerritMax[popupid][choice]:
                    if Character['xp'] >= (Character['Merrits'][MultiMerritKey[popupid][choice]]+1)*2:
                        if choice != 2 or (choice == 2 and Character['Template'] == 'Psion'):
                            Character['xp'] -= (Character['Merrits'][MultiMerritKey[popupid][choice]]+1)*2
                            Character['Merrits'][MultiMerritKey[popupid][choice]] += 1
                            AddMerrit(userid, MultiMerritKey[popupid][choice])
                            es.tell(userid, '#multi', '#defaultYou have gained dot #lightgreen%s #defaultinto #green%s'%(Format(Character['Merrits'][MultiMerritKey[popupid][choice]]), MultiMerritKey[popupid][choice]))
                        else:
                            es.tell(userid, '#multi', '#defaultYou must be a Psion to gain Biokinesis')
                    else:
                        es.tell(userid, '#multi', '#defaultYou do not have enough experience to gain a dot of %s'%MultiMerritKey[popupid][choice])
                else:
                    es.tell(userid, '#multi', '#defaultYour %s is already at max dots!'%MultiMerritKey[popupid][choice])
            elif choice == 1:
                if 'Danger Sense' not in Character['Merrits']:
                    if Character['xp'] >= 4:
                        Character['Merrits']['Danger Sense'] = 2
                        Character['xp'] -= 4
                        AddMerrit(userid, 'Danger Sense')
                        es.tell(userid, '#multi', '#defaultYou have gained the #greenDanger Sense #defaultmerrit.')
                    else:
                        es.tell(userid, '#multi', '#defaultYou do not have enough experience to gain Danger Sense')
                else:
                    es.tell(userid, '#multi', '#defaultYou already have Danger Sense')
            elif choice == 3:
                if Character['Template'] == 'Psion':
                    if Character['Merrits']['Psyic Healer'] < 5:
                        if Character['Merrits']['Psyic Healer'] == 0:
                            if Character['xp'] >= 6:
                                Character['Merrits']['Psyic Healer'] = 3
                                Character['xp'] -= 6
                                AddMerrit(userid, 'Psyic Healer')
                                es.tell(userid, '#multi', '#defaultYou have gained dots #lightgreenOOO #defaultin #greenPsyic Healer #defaultmerrit.')
                            else:
                                es.tell(userid, '#multi', '#defaultYou do not have enough experience to gain Psyic Healer')
                        else:
                            if Character['xp'] >= 10:
                                Character['Merrits']['Psyic Healer'] = 5
                                Character['xp'] -= 10
                                es.tell(userid, '#multi', '#defaultYou have gained dots #lightgreenOOOOO #defaultin #greenPsyic Healer #defaultmerrit.')
                            else:
                                es.tell(userid, '#multi', '#defaultYou do not have enough experience to gain Psyic Healer')
                    else:
                        es.tell(userid, '#multi', '#defaultYou already have max dots in Psyic Healer')
                else:
                    es.tell(userid, '#multi', '#defaultYou must be a Psion to gain Psyic Healer')

#The key is used to link the choice in the menu to the name of the merrit
MultiMerritKey = {  'merrit buy': { 5:'Fleet of Foot',
                                    1:'Resources'},
                    'merrit buy2':{ 2:'Biokinesis',
                                    4:'Iron Stamina'}}
#Defines the max dots a user can have into each merrit that can be purchased multipul times
# 1 = Resources, 5 = Fleet of Foot
#2 = Biokinesis, 4 = Iron Stamina
MultiMerritMax = {  'merrit buy': { 5:3,
                                    1:5},
                    'merrit buy2':{ 2:5,
                                    4:3}}

def AddMerrit(userid, merrit, list=1):
    '''Adds said merrit to the user's merrit list if it is not already there'''
    Key = getPlayer(userid)
    Character = Characters[Key['Character']]
    if list not in Character['Merrit Lists']:
        Character['Merrit Lists'][list] = []
    if merrit not in Character['Merrit Lists'][list]:
        if len(Character['Merrit Lists'][list]) < 5:
            Character['Merrit Lists'][list].append(merrit)
        else:
            AddMerrit(userid, merrit, list+1)

def Format(dots):
    '''returns a string containing dots (OOOO) that are formatted into a menu'''
    mydots = ''
    while dots > 0:
        mydots = '%s%s'%(mydots, 'O')
        dots -= 1
    return mydots

def mainselect(userid, choice, popupid):
    '''Is Called when a user selects an option in the main menu'''
    Key = getPlayer(userid)
    ID = Bank(userid)
    Character = Characters[Key['Character']]
    if choice == 1:
        es.cexec(userid, 'wod create')

def LoadMenuPrep(userid, popupid):
    '''Is run to prep the load/del menus for the given user (adds their character names to it'''
    Key = getPlayer(userid)
    ID = Bank(userid)
    popup = popuplib.find(popupid)
    for i in range(2, 10):
        popup.modline(i, ' --- ')
    for Character in ID:
        if Character != Key['Character']:
            popup.modline(ID.index(Character)+2, '-> %s. %s'%(ID.index(Character), Character))
        else:
            popup.modline(ID.index(Character)+2, '    %s (Current)'%(Character))

def LoadMenuSelect(userid, choice, popupid):
    '''is run when a user selects a character to load form the load menu'''
    Key = getPlayer(userid)
    ID = Bank(userid)
    if len(ID) >= choice and choice != 0:
        es.cexec(userid, 'wod load %s'%ID[choice])
    else:
        if choice < 9:
            loadmenu.send(userid)

def DelMenuSelect(userid, choice, popupid):
    '''is run when a user selects a character to load form the load menu'''
    Key = getPlayer(userid)
    ID = Bank(userid)
    if len(ID) >= choice and choice != 0:
        es.cexec(userid, 'wod del %s'%ID[choice])
    else:
        if choice < 9:
            delmenu.send(userid)

def StatsPrep(userid, popupid):
    '''preps each character info menu for each user before sending it'''
    Key = getPlayer(userid)
    ID = Bank(userid)
    Character = Characters[Key['Character']]
    popup = popuplib.find(popupid)
    if popupid == 'statmenu':
        popup.modline(1, '-{ %s\'s Information }-'%Key['Character'])
        popup.modline(2, ' Template: %s'%Character['Template'])
        popup.modline(3, ' Unspent Experience: %s'%Character['xp'])
        popup.modline(4, ' Total Experience: %s'%Character['total xp'])
    elif popupid == 'skillsmenu':
        popup.modline(1, '-{ %s\'s Skills }-'%Key['Character'])
        popup.modline(2, ' Athletics: %s'%Format(Character['Skills']['Athletics']))
        popup.modline(3, ' Firearms: %s'%Format(Character['Skills']['Firearms']))
        popup.modline(4, ' Stealth: %s'%Format(Character['Skills']['Stealth']))
        popup.modline(5, ' Larceny: %s'%Format(Character['Skills']['Larceny']))
        popup.modline(6, ' Subterfuge: %s'%Format(Character['Skills']['Subterfuge']))
        popup.modline(7, ' Occult: %s'%Format(Character['Skills']['Occult']))
    elif popupid == 'attmenu':
        popup.modline(1, '-{ %s\'s Attributes }-'%Key['Character'])
        popup.modline(2, ' Strength: %s'%Format(Character['Attributes']['Strength']))
        popup.modline(3, ' Dexterity: %s'%Format(Character['Attributes']['Dexterity']))
        popup.modline(4, ' Stamina: %s'%Format(Character['Attributes']['Stamina']))
        popup.modline(5, ' Presence: %s'%Format(Character['Attributes']['Presence']))
    elif popupid == 'mer1menu':
        popup.modline(1, '-{ %s\'s Merrits }-'%Key['Character'])
        for i in range(2, 8):
            popup.modline(i, '--')
        for merrit in Character['Merrit Lists'][1]:
            popup.modline(Character['Merrit Lists'][1].index(merrit)+2, ' %s (Dots: %s)'%(merrit, Format(Character['Merrits'][merrit])))
        if len(Character['Merrit Lists'][1]) == 5:
            popup.modline(7, '-> 8. Next')
    elif popupid == 'mer2menu':
        popup.modline(1, '-{ %s\'s Merrits }-'%Key['Character'])
        for i in range(2, 8):
            popup.modline(i, '--')
        for merrit in Character['Merrit Lists'][2]:
            popup.modline(Character['Merrit Lists'][2].index(merrit)+2, ' %s (Dots: %s)'%(merrit, Format(Character['Merrits'][merrit])))
        if len(Character['Merrit Lists'][2]) == 5:
            popup.modline(7, '-> 8. Next')
    elif popupid == 'mer3menu':
        popup.modline(1, '-{ %s\'s Merrits }-'%Key['Character'])
        for i in range(2, 8):
            popup.modline(i, '--')
        for merrit in Character['Merrit Lists'][3]:
            popup.modline(Character['Merrit Lists'][3].index(merrit)+2, ' %s (Dots: %s)'%(merrit, Format(Character['Merrits'][merrit])))

def StatsSelect(userid, choice, popupid):
    '''Used to check to see if the user needs the next menu in merrit info'''
    if choice == 9 and (popupid == 'mer1menu' or popupid == 'mer2menu'):
        Key = getPlayer(userid)
        Character = Characters[Key['Character']]
        if popupid == 'mer1menu':
            if 2 in Character['Merrit Lists']:
                popuplib.find('mer2menu').send(userid)
        elif popupid == 'mer2menu':
            if 3 in Character['Merrit Lists']:
                popuplib.find('mer3menu').send(userid)

def TemplateMenuSelect(userid, choice, popupid):
    '''Runs when some selects something from template buy'''
    Key = getPlayer(userid)
    Character = Characters[Key['Character']]
    if choice < 4:
        if Character['Template'] == 'Mortal':
            if choice == 1:
                if Character['xp'] >= 15:
                    Character['xp'] -= 15
                    Character['Template'] = 'Vampire'
                    es.tell(userid, '#multi', '#defaultYou are now a #lightgreenVampire')
            elif choice == 2:
                if Character['xp'] >= 15:
                    Character['xp'] -= 15
                    Character['Template'] = 'Werewolf'
                    es.tell(userid, '#multi', '#defaultYou are now a #lightgreenWerewolf')
            elif choice == 3:
                if Character['xp'] >= 5:
                    Character['xp'] -= 5
                    Character['Template'] = 'Psion'
                    es.tell(userid, '#multi', '#defaultYou are now a #lightgreenPsion')
        else:
            es.tell(userid, '#multi', '#defaultYou already have a supernatural template.')

def menucreate():
    '''Used to create all the starting menus for the game and link them all together'''
    global mainmenu
    mainmenu = popuplib.create('mainmenu')
    mainmenu.addline('-{ World of Darkness Main Menu }-')
    mainmenu.addline('-> 1. Create a Character')
    mainmenu.addline('-> 2. Load a Character')
    mainmenu.addline('-> 3. Current Character Information')
    mainmenu.addline('-> 4. Spend Xp')
    mainmenu.addline('-> 5. Information Menu')
    mainmenu.addline('-> 6. Help Menu')
    mainmenu.addline('-> 7. Delete a Character')
    mainmenu.addline('0. - Exit')
    mainmenu.submenu(2, 'loadmenu')
    mainmenu.submenu(3, 'statmenu')
    mainmenu.submenu(4, 'xpmenu')
    mainmenu.submenu(5, 'infomenu')
    mainmenu.submenu(6, 'welcomemenu')
    mainmenu.submenu(7, 'delmenu')
    mainmenu.menuselect = mainselect
    global loadmenu
    loadmenu = popuplib.create('loadmenu')
    loadmenu.addline('-{ Select a Character to Load }-')
    loadmenu.addline('--')
    loadmenu.addline('--')
    loadmenu.addline('--')
    loadmenu.addline('--')
    loadmenu.addline('--')
    loadmenu.addline('--')
    loadmenu.addline('--')
    loadmenu.addline('--')
    loadmenu.addline('-> 9. Back')
    loadmenu.addline('0. - Exit')
    loadmenu.submenu(9, 'mainmenu')
    loadmenu.prepuser = LoadMenuPrep
    loadmenu.menuselect = LoadMenuSelect
    global delmenu
    delmenu = popuplib.create('delmenu')
    delmenu.addline('-{ Select a Character to Remove }-')
    delmenu.addline('--')
    delmenu.addline('--')
    delmenu.addline('--')
    delmenu.addline('--')
    delmenu.addline('--')
    delmenu.addline('--')
    delmenu.addline('--')
    delmenu.addline('--')
    delmenu.addline('-> 9. Back')
    delmenu.addline('0. - Exit')
    delmenu.submenu(9, 'mainmenu')
    delmenu.prepuser = LoadMenuPrep
    delmenu.menuselect = DelMenuSelect
    global statmenu
    statmenu = popuplib.create('statmenu')
    statmenu.addline('-{ <Character>\'s Stats }-')
    statmenu.addline(' Template: xx')
    statmenu.addline(' Unspent Experience: xx')
    statmenu.addline(' Total Experience: xx')
    #statmenu.addline('-> 5. Powers')
    statmenu.addline('-> 6. Merrits')
    statmenu.addline('-> 7. Skills')
    statmenu.addline('-> 8. Attributes')
    statmenu.addline('-> 9. Back')
    statmenu.addline('0. - Exit')
    statmenu.submenu(6, 'mer1menu')
    statmenu.submenu(7, 'skillsmenu')
    statmenu.submenu(8, 'attmenu')
    statmenu.submenu(9, 'mainmenu')
    statmenu.prepuser = StatsPrep
    skillsmenu = popuplib.create('skillsmenu')
    skillsmenu.addline('-{ <Character>\'s Skills }-')
    skillsmenu.addline(' Athletics: x')
    skillsmenu.addline(' Firearms: x')
    skillsmenu.addline(' Stealth: x')
    skillsmenu.addline(' Larceny: x')
    skillsmenu.addline(' Subterfuge: x')
    skillsmenu.addline(' Occult: x')
    skillsmenu.addline('-> 9. Back')
    skillsmenu.addline('0. Exit')
    skillsmenu.submenu(9, 'statmenu')
    skillsmenu.prepuser = StatsPrep
    attmenu = popuplib.create('attmenu')
    attmenu.addline('-{ <Character>\'s Attributes }-')
    attmenu.addline(' Strength: x')
    attmenu.addline(' Dexterity: x')
    attmenu.addline(' Stamina: x')
    attmenu.addline(' Presence: x')
    attmenu.addline('-> 9. Back')
    attmenu.addline('0. Exit')
    attmenu.submenu(9, 'statmenu')
    attmenu.prepuser = StatsPrep
    mer1menu = popuplib.create('mer1menu')
    mer1menu.addline('-{ <Character>\'s Merrits }-')
    mer1menu.addline('--')
    mer1menu.addline('--')
    mer1menu.addline('--')
    mer1menu.addline('--')
    mer1menu.addline('--')
    mer1menu.addline('-> 8. Next')
    mer1menu.addline('-> 9. Back')
    mer1menu.addline('0. Exit')
    mer1menu.submenu(9, 'statmenu')
    mer1menu.prepuser = StatsPrep
    mer1menu.menuselect = StatsSelect
    mer2menu = popuplib.create('mer2menu')
    mer2menu.addline('-{ <Character>\'s Merrits }-')
    mer2menu.addline('--')
    mer2menu.addline('--')
    mer2menu.addline('--')
    mer2menu.addline('--')
    mer2menu.addline('--')
    mer2menu.addline('-> 8. Next')
    mer2menu.addline('-> 9. Back')
    mer2menu.addline('0. Exit')
    mer2menu.submenu(9, 'mer1menu')
    mer2menu.prepuser = StatsPrep
    mer2menu.menuselect = StatsSelect
    mer3menu = popuplib.create('mer3menu')
    mer3menu.addline('-{ <Character>\'s Merrits }-')
    mer3menu.addline('--')
    mer3menu.addline('--')
    mer3menu.addline('--')
    mer3menu.addline('--')
    mer3menu.addline('--')
    mer3menu.addline('-> 9. Back')
    mer3menu.addline('0. Exit')
    mer3menu.submenu(9, 'mer2menu')
    mer3menu.prepuser = StatsPrep
    global welcomemenu
    welcomemenu = popuplib.create('welcomemenu')
    welcomemenu.addline('-{ Welcome to a World of Darkness }-')
    #welcomemenu.addline('- From this point forward World of Darkness will be said as WoD -')
    welcomemenu.addline('- WoD Command List -')
    welcomemenu.addline('- WoD Menu - A main menu for the mod -')
    welcomemenu.addline('- WoD Create <Character Name> - Start creating your character -')
    welcomemenu.addline('- WoD Load <Character Name> - Load a preexisting character -')
    welcomemenu.addline('- WoD Stats - See what character your are playing -')
    welcomemenu.addline('- WoD Xp - Allows you to spend earned Experience -')
    welcomemenu.addline('- WoD Info - Displays information about different WoD features -')
    welcomemenu.addline('- WoD Default - Sets your character as your default loaded -')
    welcomemenu.addline('- WoD Help - This Menu -')
    welcomemenu.addline('-> 9. To Main Menu')
    welcomemenu.addline('0. - Exit')
    welcomemenu.submenu(9, 'mainmenu')
    global xpmenu
    xpmenu = popuplib.create('xpmenu')
    xpmenu.addline('-{ World of Darkness Xp Spending Menu }-')
    xpmenu.addline('-> 1. Merrits')
    xpmenu.addline('-> 2. Skills')
    #xpmenu.addline('-> 3. Super Natural Powers')
    xpmenu.addline('-> 4. Templates')
    xpmenu.addline('-> 5. Attributes')
    xpmenu.addline('-> 9. To Main Menu')
    xpmenu.addline('0. - Exit')
    xpmenu.submenu(1, 'merrit buy')
    xpmenu.submenu(2, 'skill buy')
    xpmenu.submenu(4, 'template menu')
    xpmenu.submenu(5, 'att buy')
    xpmenu.submenu(9, 'mainmenu')
    global infomenu
    infomenu = popuplib.create('infomenu')
    infomenu.addline('-{ World of Darkness Information Menu }-')
    infomenu.addline('-> 1. Merrits')
    infomenu.addline('-> 2. Skills')
    #infomenu.addline('-> 3. Super Natural Powers')
    infomenu.addline('-> 4. Templates')
    infomenu.addline('-> 5. Attributes')
    infomenu.addline('-> 6. Sprinting')
    infomenu.addline('-> 7. Scaling Damage and Speed')
    infomenu.addline('-> 9. To Main Menu')
    infomenu.addline('0. - Exit')
    infomenu.submenu(9, 'mainmenu')
    infomenu.submenu(1, 'merritinfo')
    infomenu.submenu(2, 'skillsinfo')
    #infomenu.submenu(3, 'powersinfo')
    infomenu.submenu(4, 'templatesinfo')
    infomenu.submenu(5, 'attributesinfo')
    infomenu.submenu(6, 'cccinfo')
    infomenu.submenu(7, 'scalinginfo')
    scalinginfo = popuplib.create('scalinginfo')
    scalinginfo.addline('-{ Scaling Damage and Speed }-')
    scalinginfo.addline(' The closer you are to death the ')
    scalinginfo.addline(' less damage you deal and the slower ')
    scalinginfo.addline(' you move.')
    scalinginfo.addline('-> 9. Back')
    scalinginfo.addline('0. - Exit')
    scalinginfo.submenu(9, 'infomenu')
    cccinfo = popuplib.create('cccinfo')
    cccinfo.addline('-{ Sprinting }-')
    cccinfo.addline(' Usage - Bind a key to +sprint')
    cccinfo.addline(' Press and hold the bound key to')
    cccinfo.addline(' gain increased speed while held.')
    cccinfo.addline(' After released, or a duration, you')
    cccinfo.addline(' move slower while you recover breath.')
    cccinfo.addline('-> 9. Back')
    cccinfo.addline('0. - Exit')
    cccinfo.submenu(9, 'infomenu')
    templatemenu = popuplib.create('template menu')
    templatemenu.addline('-{ Select a Template to Gain }-')
    templatemenu.addline('-> 1. Vampire (Xp: 15)')
    templatemenu.addline('-> 2. Werewolf (Xp: 15)')
    templatemenu.addline('-> 3. Psion (Xp: 5)')
    templatemenu.addline('-> 9. Back')
    templatemenu.addline('0. Exit')
    templatemenu.submenu(9, 'xpmenu')
    templatemenu.menuselect = TemplateMenuSelect
    attbuy = popuplib.create('att buy')
    attbuy.addline('-{ Select a Attribute to Upgrade }-')
    attbuy.addline('-> 1. Strength (Dots: x)')
    attbuy.addline('-> 2. Dexterity (Dots: x)')
    attbuy.addline('-> 3. Stamina (Dots: x)')
    attbuy.addline('-> 4. Presence (Dots: x')
    attbuy.addline('-> 9. Back')
    attbuy.addline('0. Exit')
    attbuy.submenu(9, 'xpmenu')
    attbuy.menuselect = AttBuySelect
    attbuy.prepuser = AttBuyPrep
    merritbuy = popuplib.create('merrit buy')
    merritbuy.addline('-{ Select a Merrit to Purchase }-')
    merritbuy.addline('-> 1. Resources (Dots: x)')
    merritbuy.addline('-> 2. Fighting Finesse (Dots: x)')
    merritbuy.addline('-> 3. Quick Healer (Dots: x)')
    merritbuy.addline('-> 4. Unseen Sense (Dots: x)')
    merritbuy.addline('-> 5. Fleet of Foot (Dots: x)')
    merritbuy.addline('-> 8. Next')
    merritbuy.addline('-> 9. Back')
    merritbuy.addline('0. - Exit')
    merritbuy.submenu(8, 'merrit buy2')
    merritbuy.submenu(9, 'xpmenu')
    merritbuy.prepuser = MerritBuyPrep
    merritbuy.menuselect = MerritBuySelect
    merritbuy2 = popuplib.create('merrit buy2')
    merritbuy2.addline('-{ Select a Merrit to Purchase }-')
    merritbuy2.addline('-> 1. Danager Sense (Dots: x)')
    merritbuy2.addline('-> 2. Biokinesis (Dots: x)')
    merritbuy2.addline('-> 3. Psyic Healing (Dots: x)')
    merritbuy2.addline('-> 4. Iron Stamina (Dots: x)')
    merritbuy2.addline('-> 9. Back')
    merritbuy2.addline('0. - Exit')
    merritbuy2.submenu(9, 'merrit buy')
    merritbuy2.prepuser = MerritBuyPrep
    merritbuy2.menuselect = MerritBuySelect
    skillsbuy = popuplib.create('skill buy')
    skillsbuy.addline('Select a Skill to Upgrade:')
    skillsbuy.addline('-> 1. Athletics (Dots: x)')
    skillsbuy.addline('-> 2. Firearms (Dots: x)')
    skillsbuy.addline('-> 3. Stealth (Dots: x)')
    skillsbuy.addline('-> 4. Larceny (Dots: x)')
    skillsbuy.addline('-> 5. Subterfuge (Dots: x)')
    skillsbuy.addline('-> 6. Occult (Dots: x)')
    skillsbuy.addline('-> 9. Back')
    skillsbuy.addline('0. Exit')
    skillsbuy.submenu(9, 'xpmenu')
    skillsbuy.prepuser = SkillsBuyPrep
    skillsbuy.menuselect = SkillsBuySelect
    merritinfo = popuplib.create('merritinfo')
    merritinfo.addline('Select a Merrit:')
    merritinfo.addline('-> 1. Cost')
    merritinfo.addline('-> 2. Resources')
    merritinfo.addline('-> 3. Fighting Finesse')
    merritinfo.addline('-> 4. Quick Healer')
    merritinfo.addline('-> 5. Unseen Sense')
    merritinfo.addline('-> 6. Fleet of Foot')
    merritinfo.addline('-> 7. Danager Sense')
    merritinfo.addline('-> 8. Next')
    merritinfo.addline('-> 9. Back')
    merritinfo.addline('0. Exit')
    merritinfo.submenu(1, 'merritgeneral')
    merritinfo.submenu(2, 'resourceinfo')
    merritinfo.submenu(3, 'fightingfinesseinfo')
    merritinfo.submenu(4, 'quickhealerinfo')
    merritinfo.submenu(5, 'unseeninfo')
    merritinfo.submenu(6, 'fleetoffootinfo')
    merritinfo.submenu(7, 'danagerinfo')
    merritinfo.submenu(8, 'merrit2')
    merritinfo.submenu(9, 'infomenu')
    merrit2 = popuplib.create('merrit2')
    merrit2.addline('Select a Merrit:')
    merrit2.addline('-> 1. Biokinesis')
    merrit2.addline('-> 2. Psyic Healing')
    merrit2.addline('-> 3. Iron Stamina')
    merrit2.addline('-> 9. Back')
    merrit2.addline('0. Exit')
    merrit2.submenu(1, 'biokinesisinfo')
    merrit2.submenu(2, 'psyhealerinfo')
    merrit2.submenu(3, 'ironinfo')
    merrit2.submenu(9, 'merritinfo')
    powersinfo = popuplib.create('powersinfo')
    powersinfo.addline('Select a Power:')
    powersinfo.addline('-> 1. Nightmare')
    powersinfo.addline('-> 2. Elemental Gifts')
    powersinfo.addline('-> 9. Back')
    powersinfo.addline('0. Exit')
    powersinfo.submenu(1, 'nightmareinfo')
    powersinfo.submenu(2, 'elementalinfo')
    powersinfo.submenu(9, 'infomenu')
    elementalinfo = popuplib.create('elementalinfo')
    elementalinfo.addline('Elemental Discipline:')
    elementalinfo.addline('Template Required: Werewolf')
    elementalinfo.addline('Cost: Dot*5')
    elementalinfo.addline('Effects:')
    elementalinfo.addline(' Dot1: Use the powers of water to blur the screen of your victims.')
    elementalinfo.addline(" Dot2: The power of earth pulls your victim towards the ground.")
    elementalinfo.addline(" Dot3: The power of fire burns your victims.")
    elementalinfo.addline(" Dot4: Say 'wod whirlwind' to toss the person you are looking at into the air.")
    elementalinfo.addline(" Dot5: Say 'wod flood' to begin flooding the map to slow and maybe kill all players.")
    elementalinfo.addline('-> 9. Back')
    elementalinfo.addline('0. Exit')
    elementalinfo.submenu(9, 'powersinfo')
    nightmareinfo = popuplib.create('nightmareinfo')
    nightmareinfo.addline('Nightmare Discipline:')
    nightmareinfo.addline('Template Required: Vampire')
    nightmareinfo.addline('Cost: Dot*5')
    nightmareinfo.addline('Effects:')
    nightmareinfo.addline(' Dot1: The screens of all non vampires near you shake with fear.')
    nightmareinfo.addline(" Dot2: Say 'wod dread' to reduce the skills of all around you.")
    nightmareinfo.addline(" Dot3: Say 'wod stare' to freeze the person you are looking at.")
    nightmareinfo.addline(" Dot4: Say 'wod shatter' to disrupt the person you are looking at.")
    nightmareinfo.addline(" Dot5: All non-vampires around you take damage every second.")
    nightmareinfo.addline('-> 9. Back')
    nightmareinfo.addline('0. Exit')
    nightmareinfo.submenu(9, 'powersinfo')
    attributesinfo = popuplib.create('attributesinfo')
    attributesinfo.addline('Select an Attribute:')
    attributesinfo.addline('-> 1. Cost')
    attributesinfo.addline('-> 2. Strength')
    attributesinfo.addline('-> 3. Dexterity')
    attributesinfo.addline('-> 4. Stamina')
    attributesinfo.addline('-> 5. Presence')
    attributesinfo.addline('-> 9. Back')
    attributesinfo.addline('0. Exit')
    attributesinfo.submenu(1, 'atgeneral')
    attributesinfo.submenu(2, 'strinfo')
    attributesinfo.submenu(3, 'dexinfo')
    attributesinfo.submenu(4, 'stminfo')
    attributesinfo.submenu(5, 'presenceinfo')
    attributesinfo.submenu(9, 'infomenu')
    presenceinfo = popuplib.create('presenceinfo')
    presenceinfo.addline('Presence Attribute:')
    presenceinfo.addline('Effects:')
    presenceinfo.addline(" - Increased Health and Cash")
    presenceinfo.addline('  - Bonus Health = (Dots - 1)^2')
    presenceinfo.addline('  - Bonus Cash = ((Dots - 1)^2)*300')
    presenceinfo.addline('  - Bonus Team Health = (Dots - 2)*2')
    presenceinfo.addline('  - Bonus Team Cash = (Dots - 2)*300')
    presenceinfo.addline('-> 9. Back')
    presenceinfo.addline('0. Exit')
    presenceinfo.submenu(9, 'attributesinfo')
    stminfo = popuplib.create('stminfo')
    stminfo.addline('Stamina Attribute:')
    stminfo.addline('Effects:')
    stminfo.addline(' - Increased Health')
    stminfo.addline(' - Bonus Health = ((Dots-1)^2)*2')
    stminfo.addline(' - Longer Sprinting (Extra Seconds = Dots/2)')
    stminfo.addline('-> 9. Back')
    stminfo.addline('0. Exit')
    stminfo.submenu(9, 'attributesinfo')
    dexinfo = popuplib.create('dexinfo')
    dexinfo.addline('Dexterity Attribute:')
    dexinfo.addline('Effects:')
    dexinfo.addline(' - Increased Speed')
    dexinfo.addline('  - Percent Bonus = Dots-1')
    dexinfo.addline(' - Chance to take no damage from an attack')
    dexinfo.addline('  - Percent Chance = (Dots-Attacker Dex Dots)*5')
    dexinfo.addline('-> 9. Back')
    dexinfo.addline('0. Exit')
    dexinfo.submenu(9, 'attributesinfo')
    strinfo = popuplib.create('strinfo')
    strinfo.addline('Strength Attribute:')
    strinfo.addline('Effects:')
    strinfo.addline(' - Increased Speed')
    strinfo.addline('  - Percent Bonus = (Dots-1)*2')
    strinfo.addline(' - Increased Damage')
    strinfo.addline('  - Percent Bonus = (Dots-1)^2')
    strinfo.addline('-> 9. Back')
    strinfo.addline('0. Exit')
    strinfo.submenu(9, 'attributesinfo')
    atgeneral = popuplib.create('atgeneral')
    atgeneral.addline('Cost of Upgrading an Attribute:')
    atgeneral.addline(' Cost: Dot*5')
    atgeneral.addline('-> 9. Back')
    atgeneral.addline('0. Exit')
    atgeneral.submenu(9, 'attributesinfo')
    templatesinfo = popuplib.create('templatesinfo')
    templatesinfo.addline('Select a Template:')
    templatesinfo.addline('-> 1. Vampire')
    templatesinfo.addline('-> 2. Werewolf')
    templatesinfo.addline('-> 3. Psion')
    templatesinfo.addline('-> 9. Back')
    templatesinfo.addline('0. Exit')
    templatesinfo.submenu(1, 'vampireinfo')
    templatesinfo.submenu(2, 'werewolfinfo')
    templatesinfo.submenu(3, 'psioninfo')
    templatesinfo.submenu(9, 'infomenu')
    psioninfo = popuplib.create('psioninfo')
    psioninfo.addline('Psion Template:')
    psioninfo.addline('Cost: 5')
    psioninfo.addline('Grants Access to Psion Merrits')
    psioninfo.addline('-> 9. Back')
    psioninfo.addline('0. Exit')
    psioninfo.submenu(9, 'templatesinfo')
    werewolfinfo = popuplib.create('werewolfinfo')
    werewolfinfo.addline('Werewolf Template:')
    werewolfinfo.addline('Cost: 15')
    werewolfinfo.addline('Powers:')
    werewolfinfo.addline(' Form of the Wolf:')
    werewolfinfo.addline(" - Use 'wod wolf' in chat to toggle wolf form on and off")
    werewolfinfo.addline(' - You gain extra health and speed in wolf form but can only use the knife')
    werewolfinfo.addline(' Regeneration:')
    werewolfinfo.addline(' - Heal 1 health every 2 seconds')
    werewolfinfo.addline('-> 9. Back')
    werewolfinfo.addline('0. Exit')
    werewolfinfo.submenu(9, 'templatesinfo')
    vampireinfo = popuplib.create('vampireinfo')
    vampireinfo.addline('Vampire Template:')
    vampireinfo.addline('Cost: 15')
    vampireinfo.addline('Powers:')
    vampireinfo.addline(' Torpor Sleep:')
    vampireinfo.addline(' - When you would die you instead go into a sleep for 10 seconds')
    vampireinfo.addline(' - If killed while sleeping you die')
    vampireinfo.addline('-> 9. Back')
    vampireinfo.addline('0. Exit')
    vampireinfo.submenu(9, 'templatesinfo')
    skillsinfo = popuplib.create('skillsinfo')
    skillsinfo.addline('Select a Skill:')
    skillsinfo.addline('-> 1. Cost')
    skillsinfo.addline('-> 2. Athletics')
    skillsinfo.addline('-> 3. Firearms')
    skillsinfo.addline('-> 4. Stealth')
    skillsinfo.addline('-> 5. Larceny')
    skillsinfo.addline('-> 6. Subterfuge')
    skillsinfo.addline('-> 7. Occult')
    skillsinfo.addline('-> 9. Back')
    skillsinfo.addline('0. Exit')
    skillsinfo.submenu(1, 'skillsgeneral')
    skillsinfo.submenu(2, 'athleticsinfo')
    skillsinfo.submenu(3, 'firearmsinfo')
    skillsinfo.submenu(4, 'stealthinfo')
    skillsinfo.submenu(5, 'larcenyinfo')
    skillsinfo.submenu(6, 'subterfugeinfo')
    skillsinfo.submenu(7, 'occultinfo')
    skillsinfo.submenu(9, 'infomenu')
    occultinfo = popuplib.create('occultinfo')
    occultinfo.addline('Occult Skill:')
    occultinfo.addline('Effects:')
    occultinfo.addline(' - Dot1: 10% increased damage to non-mortals')
    occultinfo.addline(' - Dot2: Your attacks have a chance to set vampires on fire')
    occultinfo.addline(' - Dot3: Your attacks slow werewolves')
    occultinfo.addline(' - Dot4: 10% to dodge attacks of non-mortals.')
    occultinfo.addline(' - Dot5: Your attacks have a chance to stun super natural creatures.')
    occultinfo.addline('-> 9. Back')
    occultinfo.addline('0. Exit')
    occultinfo.submenu(9, 'skillsinfo')
    subterfugeinfo = popuplib.create('subterfugeinfo')
    subterfugeinfo.addline('Subterfuge Skill:')
    subterfugeinfo.addline('Effects:')
    subterfugeinfo.addline(' Have a chance to appear as the opposing Team')
    subterfugeinfo.addline('Chance:')
    subterfugeinfo.addline(' - (Dots^2)*3')
    subterfugeinfo.addline('-> 9. Back')
    subterfugeinfo.addline('0. Exit')
    subterfugeinfo.submenu(9, 'skillsinfo')
    larcenyinfo = popuplib.create('larcenyinfo')
    larcenyinfo.addline('Larceny Skill:')
    larcenyinfo.addline('Effects:')
    larcenyinfo.addline(" Have a chance to steal 25% of each user's cash on the other team.")
    larcenyinfo.addline(' - Chance: Dots^2')
    larcenyinfo.addline('-> 9. Back')
    larcenyinfo.addline('0. Exit')
    larcenyinfo.submenu(9, 'skillsinfo')
    stealthinfo = popuplib.create('stealthinfo')
    stealthinfo.addline('Stealth Skill:')
    stealthinfo.addline('Effects:')
    stealthinfo.addline(" When crouching or walking you are harder to see")
    stealthinfo.addline(' Gain Damage bonus = Dots*10%')
    stealthinfo.addline('Stealth Color Formula:')
    stealthinfo.addline(' ((Dex Dots)^2)*2 + ((Stealth Dots)^2)*2 + 140')
    stealthinfo.addline('-> 9. Back')
    stealthinfo.addline('0. Exit')
    stealthinfo.submenu(9, 'skillsinfo')
    skillsgeneral = popuplib.create('skillsgeneral')
    skillsgeneral.addline('Cost to Gain or Upgrade a Skill:')
    skillsgeneral.addline('Cost: Dot*3')
    skillsgeneral.addline('-> 9. Back')
    skillsgeneral.addline('0. Exit')
    skillsgeneral.submenu(9, 'skillsinfo')
    athleticsinfo = popuplib.create('athleticsinfo')
    athleticsinfo.addline('Athletics Skill:')
    athleticsinfo.addline('Effects:')
    athleticsinfo.addline(" - Longer Sprinting (Extra Seconds = Dots/2)")
    athleticsinfo.addline(' - Higher Jumping (Percent = Dots^2)')
    athleticsinfo.addline(' - Increased Speed (Percent = Dots)')
    athleticsinfo.addline('-> 9. Back')
    athleticsinfo.addline('0. Exit')
    athleticsinfo.submenu(9, 'skillsinfo')
    firearmsinfo = popuplib.create('firearmsinfo')
    firearmsinfo.addline('Firearms Skill:')
    firearmsinfo.addline('Effect Bonus Damage with all Guns')
    firearmsinfo.addline('Bonus Damage Formula:')
    firearmsinfo.addline(' Percent Bonus: ((Dots-1)^2)+1')
    firearmsinfo.addline('-> 9. Back')
    firearmsinfo.addline('0. Exit')
    firearmsinfo.submenu(9, 'skillsinfo')
    merritgeneral = popuplib.create('merritgeneral')
    merritgeneral.addline('Cost to Gain or Upgrade a Merrit:')
    merritgeneral.addline('Cost: Dot*2')
    merritgeneral.addline('-> 9. Back')
    merritgeneral.addline('0. Exit')
    merritgeneral.submenu(9, 'merritinfo')
    psyhealerinfo = popuplib.create('psyhealerinfo')
    psyhealerinfo.addline('Psyic Healer Merrit:')
    psyhealerinfo.addline('Requirements: Psion')
    psyhealerinfo.addline('Dots: OOO and OOOOO')
    psyhealerinfo.addline('Effects:')
    psyhealerinfo.addline(' - OOO - Recover 1 health every 2 seconds.')
    psyhealerinfo.addline(' - OOOOO - Use wod heal to trade health to heal the targeted player over 10 seconds.')
    psyhealerinfo.addline('-> 9. Back')
    psyhealerinfo.addline('0. Exit')
    psyhealerinfo.submenu(9, 'merrit2')
    biokinesisinfo = popuplib.create('biokinesisinfo')
    biokinesisinfo.addline('Biokinesis Merrit:')
    biokinesisinfo.addline('Requirements: Psion')
    biokinesisinfo.addline('Dots: O to OOOOO')
    biokinesisinfo.addline('Effect: Gives the user different selected bonuses at the start of every round.')
    biokinesisinfo.addline('-> 9. Back')
    biokinesisinfo.addline('0. Exit')
    biokinesisinfo.submenu(9, 'merrit2')
    fleetoffootinfo = popuplib.create('fleetoffootinfo')
    fleetoffootinfo.addline('Fleet of Foot Merrit:')
    fleetoffootinfo.addline('Requirements: None')
    fleetoffootinfo.addline('Dots: O to OOO')
    fleetoffootinfo.addline('Effect: +3% Speed Per Dot')
    fleetoffootinfo.addline('-> 9. Back')
    fleetoffootinfo.addline('0. Exit')
    fleetoffootinfo.submenu(9, 'merritinfo')
    danagerinfo = popuplib.create('danagerinfo')
    danagerinfo.addline('Danager Sense Merrit:')
    danagerinfo.addline('Requirements: None')
    danagerinfo.addline('Dots: OO')
    danagerinfo.addline('Effect: +5% to your dodge attack chance')
    danagerinfo.addline('-> 9. Back')
    danagerinfo.submenu(9, 'merritinfo')
    danagerinfo.addline('0. Exit')
    unseeninfo = popuplib.create('unseeninfo')
    unseeninfo.addline('Unseen Sense Merrit:')
    unseeninfo.addline('Requirements: Mortal Template')
    unseeninfo.addline('Dots: OOO')
    unseeninfo.addline('Effect: Dodge the first attack from a supernatural Create each round')
    unseeninfo.addline('-> 9. Back')
    unseeninfo.addline('0. Exit')
    unseeninfo.submenu(9, 'merritinfo')
    resourceinfo = popuplib.create('resourceinfo')
    resourceinfo.addline('Resources Merrit:')
    resourceinfo.addline('Requirements: None')
    resourceinfo.addline('Dots: O to OOOOO')
    resourceinfo.addline('Effect: Determines the amount of cash you spawn with.')
    resourceinfo.addline('Cash Formula:')
    resourceinfo.addline(' 1500 + (Dots^2)*300')
    resourceinfo.addline('-> 9. Back')
    resourceinfo.addline('0. Exit')
    resourceinfo.submenu(9, 'merritinfo')
    quickhealerinfo = popuplib.create('quickhealerinfo')
    quickhealerinfo.addline('Quick Healer Merrit:')
    quickhealerinfo.addline('Requirements: Stamina OOOO')
    quickhealerinfo.addline('Dots: OOOO')
    quickhealerinfo.addline('Effect: Recover 1 health every 2 seconds.')
    quickhealerinfo.addline('-> 9. Back')
    quickhealerinfo.addline('0. Exit')
    quickhealerinfo.submenu(9, 'merritinfo')
    fightingfinesseinfo = popuplib.create('fightingfinesseinfo')
    fightingfinesseinfo.addline('Fighting Finesse Merrit:')
    fightingfinesseinfo.addline('Requirements: Dexterity OOO')
    fightingfinesseinfo.addline('Dots: OOO')
    fightingfinesseinfo.addline('Effect: Use your Dexterity dots for bonus damage instead of strength.')
    fightingfinesseinfo.addline('-> 9. Back')
    fightingfinesseinfo.addline('0. Exit')
    fightingfinesseinfo.submenu(9, 'merritinfo')
    ironinfo = popuplib.create('ironinfo')
    ironinfo.addline('Iron Stamina Merrit:')
    ironinfo.addline('Requiements: Stamina - Dots')
    ironinfo.addline('Dots: O-OOO')
    ironinfo.addline('Effect: Reduces and eventually removes scaling damage penalties.')
    ironinfo.addline('-> 9. Back')
    ironinfo.addline('0. Exit')
    ironinfo.submenu(9, 'merrit2')
    global biomenu
    biomenu = popuplib.create('biomenu')
    biomenu.addline('-{ Biokinesis Upgrades }-')
    biomenu.addline('- Points Remaining - x -')
    biomenu.addline('-> 1. Bonus Health (x)')
    biomenu.addline('-> 2. Bonus Speed (x)')
    biomenu.addline('-> 3. Regeneration (x)')
    biomenu.addline('-> 4. Increased Dodging (x)')
    biomenu.addline('-> 5. Damage Reduction (x)')
    biomenu.prepuser = BioMenuPrep
    biomenu.menuselect = BioMenuSelect
    for i in range(6, 10):
        biomenu.submenu(i, 'biomenu')
